<?php
/* Ĉi tiu dosiero estas parto de Pâturage
 * 
 * Copyright (C) 2007 - Guillaume Savaton <llumeao@gmail.com>
 * 
 * Pâturage  estas libera programo;  vi  povas  ĝin  pludistribui  kaj/aŭ
 * modifi je la  kondiĉoj de la GNUa Ĝenerala Publika Permesilo, eldonita
 * de «Free Software Foundation», laŭ la versio 2 de tiu Permesilo aŭ, se
 * vi preferas, ajna posta versio.
 * 
 * Ni distribuas  ĉi tiun  programon esperante  ke ĝi estos  utila, tamen
 * SEN IA AJN GARANTIO,  i.a. sen la implica garantio pri SURMERKATIGEBLO
 * aŭ  TAŬGECO POR IU KONKRETA CELO. Pliajn  detalojn  vidu  en  la  GNUa
 * Ĝenerala Publika Permesilo.
 * 
 * Ekzemplero  de  la  GNUa  Ĝenerala Publika    Permesilo   devas   esti
 * liverita al vi kun ĉi tiu programo; ricevis, turnu vin al
 * 
 * Free Software Foundation
 * 51 Franklin Street, Fifth Floor
 * Boston, MA 02110-1301, USA
 * ------------------------------------------------------------------- */
?>
<?php
   require_once('klasoj/artikla-vidajho.php');

   class PGAlbumaVidajho extends PGKolektaVidajho {

      function PGAlbumaVidajho($artiklo) {
         $this->PGKolektaVidajho($artiklo);
      }

      function leguURLonPorAgo($ago) {
         switch($ago) {

            case 'antaua':
            case 'antaua-neebla':
               return 'javascript:antauaLumbildo()';

            case 'sekva':
            case 'sekva-neebla':
               return 'javascript:sekvaLumbildo()';

            default:
               return parent::leguURLonPorAgo($ago);
         }
      }

      function leguHelpilonPorAgo($ago) {
         global $kunteksto;
         switch($ago) {

            case 'antaua':
            case 'antaua-neebla':
               return $kunteksto->leguTradukon('Antaŭa bildo');

            case 'sekva':
            case 'sekva-neebla':
               return $kunteksto->leguTradukon('Sekva bildo');

            default:
               return parent::leguHelpilonPorAgo($ago);
         }
      }

      function vidiguSuperflugon() {
         /// @todo Superflugo por albumoj estos subtenata en venonta eldono
         parent::vidiguSuperflugon();
      }

      function vidiguLumbildon() {
         global $kunteksto;
         $selektitajArtikloj = $this->_artiklo->kielKolektoLeguArtiklojn(!$kunteksto->chuGasto());
         if(count($selektitajArtikloj) == 0) {
            PGAranghisto::malfermuSekcionKunKlaso('pg-artiklo-stato');
            echo $kunteksto->leguTradukon('Tiu albumo estas malplena');
            PGAranghisto::fermuSekcion();
         }
         else {
            $artiklaVidajho = PGFabriko::leguLumbildanVidajhonPorArtiklo($selektitajArtikloj[0]);
            $artiklaVidajho->vidiguLumbildanKontenilon();
            PGAranghisto::inkluzivuSkripton('skriptoj/albumo.js');
         }
      }

      function vidiguButononAlAntauaBildo() {
         global $kunteksto;
         include($kunteksto->leguDosierIndikonAlShablono('maldekstra-butono-en-miniatura-rubando'));
      }

      function vidiguButononAlSekvaBildo() {
         global $kunteksto;
         include($kunteksto->leguDosierIndikonAlShablono('dekstra-butono-en-miniatura-rubando'));
      }

      function vidiguMiniaturRubandon() {
         global $piktogramoj, $kunteksto;
         include($kunteksto->leguDosierIndikonAlShablono('miniatura-rubando'));
         $selektitajArtikloj = $this->_artiklo->kielKolektoLeguArtiklojn(!$kunteksto->chuGasto());
         foreach($selektitajArtikloj as $e)
            $selektitajArtiklajVidajhoj[] = PGFabriko::leguLumbildanVidajhonPorArtiklo($e);
?>
         <script type="text/javascript">
            <!--
            var miniaturURLoj = new Array(
<?php
                  $komenco = true;
                  foreach($selektitajArtiklajVidajhoj as $e) {
                     if(!$komenco)
                        echo ',';
                     else
                        $komenco = false;
                     echo '"' . $e->leguURLonAlMiniaturo() . '"';
                  }
?>
               );

            var bildURLoj = new Array(
<?php
                  $komenco = true;
                  foreach($selektitajArtiklajVidajhoj as $e) {
                     if(!$komenco)
                        echo ',';
                     else
                        $komenco = false;
                     echo '"' . $kunteksto->leguURLonAlLumbildaVidajho($e->leguArtiklon()) . '"';
                  }
?>
               );

            var antauaSagoEbla = '<?php echo $kunteksto->leguDosierIndikonAlPiktogramujo() . "/{$piktogramoj['antaua']}" ?>';
            var antauaSagoNeebla = '<?php echo $kunteksto->leguDosierIndikonAlPiktogramujo() . "/{$piktogramoj['antaua-neebla']}" ?>';
            var sekvaSagoEbla = '<?php echo $kunteksto->leguDosierIndikonAlPiktogramujo() . "/{$piktogramoj['sekva']}" ?>';
            var sekvaSagoNeebla = '<?php echo $kunteksto->leguDosierIndikonAlPiktogramujo() . "/{$piktogramoj['sekva-neebla']}" ?>';
            -->
         </script>
<?php
      }

      function vidiguMiniaturojnEnRubando() {
         global $kunteksto;
         $selektitajArtikloj = $this->_artiklo->kielKolektoLeguArtiklojn(!$kunteksto->chuGasto());
         if(count($selektitajArtikloj) == 0) {
            PGAranghisto::malfermuSekcionKunKlaso('pg-artiklo-stato');
            echo $kunteksto->leguTradukon('Tiu albumo estas malplena');
            PGAranghisto::fermuSekcion();
         }
         else {
            for($i = 0 ;
                $i < count($selektitajArtikloj) && $i < $kunteksto->leguAgordonPriNombroDaMiniaturojEnAlbumoj() ;
                $i++
            ) {
               $artiklaVidajho = PGFabriko::leguLumbildanVidajhonPorArtiklo($selektitajArtikloj[$i]);
               $artiklaVidajho->vidiguMiniaturon();
            }
         }
      }

      function vidiguPiktogramonPorAgo($ago) {
         global $kunteksto;
         switch($ago) {

            case 'antaua':
               parent::vidiguPiktogramonPorAgo('antaua-neebla', 'pg-antaua');
               break;

            case 'sekva':
               $selektitajArtikloj = $this->_artiklo->kielKolektoLeguArtiklojn(!$kunteksto->chuGasto());
               if(count($selektitajArtikloj) > $kunteksto->leguAgordonPriNombroDaMiniaturojEnAlbumoj())
                  parent::vidiguPiktogramonPorAgo('sekva', 'pg-sekva');
               else
                  parent::vidiguPiktogramonPorAgo('sekva-neebla', 'pg-sekva');
               break;

            default:
               parent::vidiguPiktogramonPorAgo($ago);
         }
      }
   }
?>
