<?php
/* Ĉi tiu dosiero estas parto de Pâturage
 * 
 * Copyright (C) 2007 - Guillaume Savaton <llumeao@gmail.com>
 * 
 * Pâturage  estas libera programo;  vi  povas  ĝin  pludistribui  kaj/aŭ
 * modifi je la  kondiĉoj de la GNUa Ĝenerala Publika Permesilo, eldonita
 * de «Free Software Foundation», laŭ la versio 2 de tiu Permesilo aŭ, se
 * vi preferas, ajna posta versio.
 * 
 * Ni distribuas  ĉi tiun  programon esperante  ke ĝi estos  utila, tamen
 * SEN IA AJN GARANTIO,  i.a. sen la implica garantio pri SURMERKATIGEBLO
 * aŭ  TAŬGECO POR IU KONKRETA CELO. Pliajn  detalojn  vidu  en  la  GNUa
 * Ĝenerala Publika Permesilo.
 * 
 * Ekzemplero  de  la  GNUa  Ĝenerala Publika    Permesilo   devas   esti
 * liverita al vi kun ĉi tiu programo; ricevis, turnu vin al
 * 
 * Free Software Foundation
 * 51 Franklin Street, Fifth Floor
 * Boston, MA 02110-1301, USA
 * ------------------------------------------------------------------- */
?>
<?php
   class PGAranghisto {

      function vidiguMalnepranAtributon($atr, $valoro, $anstatau='') {
         if($valoro == '') {
            if($anstatau != '')
               echo "$atr=\"$anstatau\" ";
         }
         else
            echo "$atr=\"$valoro\" ";
      }

      function vidiguTekston($teksto, $klaso='') {
         if($klaso == '')
            echo $teksto;
         else {
            ?><span class="<?php echo $klaso ?>"><?php echo $teksto ?></span><?php
         }
      }

      function vidiguTekstanLigilon($teksto, $celaUrl, $helpilo='', $klaso='', $stilo='', $alPatraKadro=false) {
?>
         <a href="<?php echo $celaUrl ?>"
<?php
            if($alPatraKadro) {
?>
               onclick="parent.location=this.href"
<?php
            }

            PGAranghisto::vidiguMalnepranAtributon('title', $helpilo);
            PGAranghisto::vidiguMalnepranAtributon('class', $klaso);
            PGAranghisto::vidiguMalnepranAtributon('style', $stilo);
?>
         ><?php echo $teksto ?></a><?php
      }

      function vidiguBildanLigilon($urlDeBildo, $celaUrl, $helpilo='', $nomo='', $klaso='', $alPatraKadro=false) {
?>
         <a href="<?php echo $celaUrl ?>"
<?php
            if($alPatraKadro) {
?>
               onclick="parent.location=this.href"
<?php
            }

            PGAranghisto::vidiguMalnepranAtributon('title', $helpilo);
?>
         ><img src="<?php echo $urlDeBildo ?>" 
<?php
               PGAranghisto::vidiguMalnepranAtributon('id', $nomo);
               PGAranghisto::vidiguMalnepranAtributon('class', $klaso);
               PGAranghisto::vidiguMalnepranAtributon('alt', $helpilo, $urlDeBildo);
?>
         /></a>
<?php
      }

      function vidiguBildon($urlDeBildo, $nomo='', $klaso='') {
?>
         <img src="<?php echo $urlDeBildo ?>" 
<?php
               PGAranghisto::vidiguMalnepranAtributon('name', $nomo);
               PGAranghisto::vidiguMalnepranAtributon('class', $klaso);
               PGAranghisto::vidiguMalnepranAtributon('alt', $urlDeBildo);
?>
         />
<?php
      }

      function vidiguPretaranghitanTekston($teksto) {
?>
         <pre><?php echo htmlentities($teksto) ?></pre>
<?php
      }

      function inkluzivuStilfolion($url) {
?>
         <link href="<?php echo $url ?>"
               rel="stylesheet"
               type="text/css"
               media="all" />
<?php
      }

      function vidiguEnigilon($teksto, $tipo, $nomo, $valoro, $ligilo='') {
         switch($tipo) {
            case 'textarea':
               if($teksto != '') {
?>
                  <div class="pg-kampo-nomo"><?php echo $teksto ?></div>
<?php
               }
?>
               <div>
                  <textarea name="<?php echo $nomo ?>"
                            rows=""
                            cols=""
                  ><?php
                     echo $valoro
                  ?></textarea>
               </div>
<?php
               break;

            case 'checkbox':
            case 'radio':
?>
               <div class="pg-kampo-nomo">
                  <input type="<?php echo $tipo ?>"
                        name="<?php echo $nomo ?>"
<?php
                     if($valoro)
                        echo 'checked="checked"';
?>
                  />
                  <?php echo $teksto ?>
               </div>
<?php
               break;

            case 'button':
            case 'submit':
?>
               <input type="<?php echo $tipo ?>"
                      name="<?php echo $nomo ?>"
                      value="<?php echo $valoro ?>"
<?php
               if($ligilo != '') {
?>
                      onclick="self.location.href='<?php echo $ligilo ?>'"
<?php
               }
?>
                  />
<?php
               break;

            default:
               if($teksto != '') {
?>
                  <div class="pg-kampo-nomo"><?php echo $teksto ?></div>
<?php
               }
?>
               <div>
                  <input type="<?php echo $tipo ?>"
                         name="<?php echo $nomo ?>"
                         value="<?php echo $valoro ?>"
<?php
               if($ligilo != '') {
?>
                         onclick="self.location.href='<?php echo $ligilo ?>'"
<?php
               }
?>
                  />
               </div>
<?php
         }
      }

      function vidiguKashitanEnigilon($nomo, $valoro) {
?>
         <input type="hidden"
                name="<?php echo $nomo ?>"
                value="<?php echo $valoro ?>" />
<?php
      }

      function malfermuRadiobutonanListon($teksto, $nomo) {
?>
         <div class="pg-kampo-nomo">
            <?php echo $teksto ?>
         </div>
         <select name="<?php echo $nomo ?>">
<?php
      }

      function vidiguOpcion($valoro, $teksto, $selektita=false) {
?>
         <option value="<?php echo $valoro ?>"
<?php
         if($selektita)
            echo 'selected="selected"';
?>
         ><?php echo $teksto ?></option>
<?php
      }

      function fermuRadiobutonanListon() {
?>
            </select>
<?php
      }

      function malfermuFormularon($nomo, $kodosistemo, $ago, $metodo) {
?>
         <form id="<?php echo $nomo ?>"
               enctype="<?php echo $kodosistemo ?>"
               action="<?php echo $ago ?>"
               method="<?php echo $metodo ?>">
<?php
      }

      function fermuFormularon() {
?>
         </form>
<?php
      }

      function vidiguTitolon($nivelo, $teksto) {
?>
         <h<?php echo $nivelo ?>><?php echo $teksto ?></h<?php echo $nivelo ?>>
<?php
      }

      function malfermuSekcionKunIdentigilo($id) {
?>
         <div id="<?php echo $id ?>">
<?php
      }

      function malfermuSekcionKunKlaso($klaso) {
?>
         <div class="<?php echo $klaso ?>">
<?php
      }

      function fermuSekcion() {
?>
         </div>
<?php
      }

      function malfermuKadron($nomo, $klaso, $fonto) {
?>
         <iframe id="<?php echo $nomo ?>"
                 class="<?php echo $klaso ?>"
                 src="<?php echo $fonto ?>">
<?php
      }

      function fermuKadron() {
?>
         </iframe>
<?php
      }

      function inkluzivuSkripton($url) {
?>
         <script type="text/javascript" src="<?php echo $url ?>"></script>
<?php
      }
   }
?>
