<?php
/* Ĉi tiu dosiero estas parto de Pâturage
 * 
 * Copyright (C) 2007 - Guillaume Savaton <llumeao@gmail.com>
 * 
 * Pâturage  estas libera programo;  vi  povas  ĝin  pludistribui  kaj/aŭ
 * modifi je la  kondiĉoj de la GNUa Ĝenerala Publika Permesilo, eldonita
 * de «Free Software Foundation», laŭ la versio 2 de tiu Permesilo aŭ, se
 * vi preferas, ajna posta versio.
 * 
 * Ni distribuas  ĉi tiun  programon esperante  ke ĝi estos  utila, tamen
 * SEN IA AJN GARANTIO,  i.a. sen la implica garantio pri SURMERKATIGEBLO
 * aŭ  TAŬGECO POR IU KONKRETA CELO. Pliajn  detalojn  vidu  en  la  GNUa
 * Ĝenerala Publika Permesilo.
 * 
 * Ekzemplero  de  la  GNUa  Ĝenerala Publika    Permesilo   devas   esti
 * liverita al vi kun ĉi tiu programo; ricevis, turnu vin al
 * 
 * Free Software Foundation
 * 51 Franklin Street, Fifth Floor
 * Boston, MA 02110-1301, USA
 * ------------------------------------------------------------------- */
?>
<?php
   require_once('klasoj/kunteksto.php');
   require_once('klasoj/artiklo.php');
   require_once('klasoj/aranghisto.php');
   require_once('klasoj/vidajho.php');
   require_once(PGKunteksto::leguDosierIndikonAlPiktogramKatalogo());

   class PGArtiklaVidajho extends PGVidajho {

      var $_artiklo;

      function PGArtiklaVidajho($artiklo) {
         $this->_artiklo = $artiklo;
      }

      function leguURLonPorAgo($ago) {
         global $kunteksto;
         switch($ago) {

            case 'hejmen':
               return $kunteksto->leguURLonAlPatraPagho();

            case 'redaktu':
               return $kunteksto->leguURLonAlRedaktaVidajho($this->_artiklo);

            case 'forigu':
               return $kunteksto->leguURLonPorForigiArtiklon($this->_artiklo);

            case 'vidigu':
            default:
               return $kunteksto->leguURLonAlArtiklaVidajho($this->_artiklo);
         }
      }

      function leguHelpilonPorAgo($ago) {
         global $kunteksto;
         switch($ago) {

            case 'hejmen':
               return $kunteksto->leguTradukon('Retroen al foliumilo');

            case 'redaktu':
               return $kunteksto->leguTradukon('Redaktu la atributojn de tiu artiklo');

            case 'forigu':
               return $kunteksto->leguTradukon('Forigu tiun artiklon');

            case 'vidigu':
            default:
               return $kunteksto->leguTradukon('Vidigu tiun artiklon');
         }
      }

      function leguTekstonPorKampo($kampo) {
         global $kunteksto;
         switch($kampo) {

            case 'nomo':
               return htmlentities($this->_artiklo->leguNomon(), ENT_QUOTES, $kunteksto->leguAgordonPriKodosistemoEnHTML());

            case 'titolo':
               return htmlentities($this->_artiklo->leguTitolon(), ENT_QUOTES, $kunteksto->leguAgordonPriKodosistemoEnHTML());

            case 'priskribo':
               return htmlentities($this->_artiklo->leguPriskribon(), ENT_QUOTES, $kunteksto->leguAgordonPriKodosistemoEnHTML());

            case 'kreita':
               return date('j M Y, G:i:s', $this->_artiklo->leguKreanDaton());

            case 'modifita':
               return date('j M Y, G:i:s', $this->_artiklo->leguModifanDaton());
         }
      }

      function leguDosierIndikonAlPiktogramo() {
         global $piktogramoj, $kunteksto;
         return $kunteksto->leguDosierIndikonAlPiktogramujo() . '/' . $piktogramoj[$this->_artiklo->leguTiponKielCheno()];
      }

      function leguDosierIndikonAlPiktogramoPorAgo($ago) {
         global $piktogramoj, $kunteksto;
         return $kunteksto->leguDosierIndikonAlPiktogramujo() . "/{$piktogramoj[$ago]}";
      }

      function leguArtiklon() {
         return $this->_artiklo;
      }

      function vidiguEnFoliumilo() {
         global $kunteksto;
         include($kunteksto->leguDosierIndikonAlShablono('artiklo-en-foliumilo'));
      }

      function vidiguEnKolekto() {
         global $kunteksto;
         include($kunteksto->leguDosierIndikonAlShablono('artiklo-en-kolekto'));
      }

      function vidiguTipon() {
         echo $this->element->leguTiponKielCheno();
      }

      function vidigu() {
         global $kunteksto;
         include($kunteksto->leguDosierIndikonAlShablono($this->_artiklo->leguTiponKielCheno()));
      }

      function vidiguLigilon($ago, $kampo) {
         global $kunteksto;
         PGAranghisto::vidiguTekstanLigilon(
               $this->leguTekstonPorKampo($kampo),
               $this->leguURLonPorAgo($ago),
               $this->leguHelpilonPorAgo($ago),
               '', '', $kunteksto->chuEnLumbildo()
            );
      }

      function vidiguTekston($kampo) {
         echo $this->leguTekstonPorKampo($kampo);
      }

      function vidiguPiktogramon($ago='') {
         global $kunteksto;
         if($ago == '')
            PGAranghisto::vidiguBildon($this->leguDosierIndikonAlPiktogramo());
         else
            PGAranghisto::vidiguBildanLigilon(
                  $this->leguDosierIndikonAlPiktogramo(),
                  $this->leguURLonPorAgo($ago),
                  $this->leguHelpilonPorAgo($ago),
                  '', '', $kunteksto->chuEnLumbildo()
               );
      }

      function vidiguPiktogramonPorAgo($ago, $nomo='') {
         global $kunteksto;

         if($ago == 'elshutu' && $this->_artiklo->chuKolekto())
            return;

         if($kunteksto->chuAgoEstasPermesita($ago))
            PGAranghisto::vidiguBildanLigilon(
                  $this->leguDosierIndikonAlPiktogramoPorAgo($ago),
                  $this->leguURLonPorAgo($ago),
                  $this->leguHelpilonPorAgo($ago),
                  $nomo, '', $kunteksto->chuEnLumbildo()
               );
      }

      function vidiguPermesanPiktogramon() {
         global $piktogramoj, $kunteksto;
         if($this->_artiklo->chuPrivata())
            PGAranghisto::vidiguBildon($kunteksto->leguDosierIndikonAlPiktogramujo() . "/{$piktogramoj['privata']}");
      }

      function vidiguRangon() {
         global $piktogramoj, $kunteksto;
         for($i=0;$i<$this->_artiklo->leguRangon();$i++)
            PGAranghisto::vidiguBildon($kunteksto->leguDosierIndikonAlPiktogramujo() . "/{$piktogramoj['rangomarko-shaltita']}");
         for(;$i<$kunteksto->leguAgordonPriNombroDaRangoj();$i++)
            PGAranghisto::vidiguBildon($kunteksto->leguDosierIndikonAlPiktogramujo() . "/{$piktogramoj['rangomarko-neshaltita']}");
      }

      function vidiguEtikedojn() {
         global $kunteksto;
         $etikedoj = $this->_artiklo->leguEtikedojn();
         $komenco = true;
         foreach($etikedoj as $t) {
            if($komenco)
               $komenco = false;
            else
               echo ', ';
            PGAranghisto::vidiguTekstanLigilon(
                  $t->leguNomon(),
                  $kunteksto->leguURLonAlFoliumaVidajho($t->leguIdentigilon()),
                  $kunteksto->leguTradukon('Vidigu ĉiujn artiklojn, kiuj havas tiun etikedon')
               );
         }
      }

      function vidiguKolektojn() {
         global $kunteksto;
         $kolektoj = $this->_artiklo->leguKolektojn();
         $komenco = true;
         foreach($kolektoj as $c) {
            if($komenco)
               $komenco = false;
            else
               echo ', ';
            PGAranghisto::vidiguTekstanLigilon(
                  $c->leguNomon(),
                  $kunteksto->leguURLonAlArtiklaVidajho($c),
                  $kunteksto->leguTradukon('Vidigu tiun kolekton')
               );
         }
      }

      function vidiguSuperflugon() {
         // Malplena
      }
   
   }

?>
