<?php
/* Ĉi tiu dosiero estas parto de Pâturage
 * 
 * Copyright (C) 2007 - Guillaume Savaton <llumeao@gmail.com>
 * 
 * Pâturage  estas libera programo;  vi  povas  ĝin  pludistribui  kaj/aŭ
 * modifi je la  kondiĉoj de la GNUa Ĝenerala Publika Permesilo, eldonita
 * de «Free Software Foundation», laŭ la versio 2 de tiu Permesilo aŭ, se
 * vi preferas, ajna posta versio.
 * 
 * Ni distribuas  ĉi tiun  programon esperante  ke ĝi estos  utila, tamen
 * SEN IA AJN GARANTIO,  i.a. sen la implica garantio pri SURMERKATIGEBLO
 * aŭ  TAŬGECO POR IU KONKRETA CELO. Pliajn  detalojn  vidu  en  la  GNUa
 * Ĝenerala Publika Permesilo.
 * 
 * Ekzemplero  de  la  GNUa  Ĝenerala Publika    Permesilo   devas   esti
 * liverita al vi kun ĉi tiu programo; ricevis, turnu vin al
 * 
 * Free Software Foundation
 * 51 Franklin Street, Fifth Floor
 * Boston, MA 02110-1301, USA
 * ------------------------------------------------------------------- */
?>
<?php

   require_once('klasoj/datumbazo.php');
   require_once('klasoj/fabriko.php');
   require_once('klasoj/dosiero.php');

   class PGArtiklo {

      var $_id;
      var $_nomo;
      var $_prefikso;
      var $_sufikso;
      var $_titolo;
      var $_priskribo;
      var $_chuKolekto;
      var $_chuLegosigno;
      var $_chuAlbumo;
      var $_rango;
      var $_kreita;
      var $_redaktita;
      var $_chuPrivata;

      var $_modifita;
      var $_shargita;

      // private
      function sharguSeNecesa() {
         global $datumbazo;
         if($this->_shargita)
            return;

         $datumbazo->petu(
                     "select * " .
                     "from " . PGKunteksto::leguTabelNomon('artikloj') . " " .
                     "where id={$this->_id}"
                  );

         $this->_nomo = $datumbazo->leguRezultonPorShlosilo('nomo');
         $this->_prefikso = $datumbazo->leguRezultonPorShlosilo('prefikso');
         $this->_sufikso = $datumbazo->leguRezultonPorShlosilo('sufikso');
         $this->_titolo = $datumbazo->leguRezultonPorShlosilo('titolo');
         $this->_priskribo = $datumbazo->leguRezultonPorShlosilo('priskribo');
         $this->_rango = $datumbazo->leguRezultonPorShlosilo('rango');
         $this->_chuKolekto = $datumbazo->leguRezultonPorShlosilo('chuKolekto') == 1;
         $this->_chuLegosigno = $datumbazo->leguRezultonPorShlosilo('chuLegosigno') == 1;
         $this->_chuAlbumo = $datumbazo->leguRezultonPorShlosilo('chuAlbumo') == 1;
         $this->_kreita = strtotime($datumbazo->leguRezultonPorShlosilo('kreita'));
         $this->_redaktita = strtotime($datumbazo->leguRezultonPorShlosilo('redaktita'));
         $this->_chuPrivata = $datumbazo->leguRezultonPorShlosilo('chuPrivata') == 1;

         $this->_shargita = true;
      }

      function forigu() {
         global $datumbazo, $kunteksto;

         // Se la artiklo estas pri dosiero, forigu ĝin el la servilo
         if($this->chuDosiero()) {
            $rezulto = unlink(PGKunteksto::leguDosierIndikonAlDosierDeponejo() . '/' . $this->leguKompletanNomon());
            if(!$rezulto)
               $kunteksto->skribuMesaghon('averto', $kunteksto->leguTradukon('Malsukcesis forigi la dosieron: ') . $this->leguNomon());
         }

         // Se la artiklo estas kolekto, forigu ĉiujn ligojn al ĝia enhavo
         $datumbazo->petu(
                     "delete from " . PGKunteksto::leguTabelNomon('rel_artikloj_kolektoj') . " " .
                     "where kolekto={$this->_id}"
                  );

         // Se la artiklo estas en kolektoj, forigu la ligojn inter ĝi kaj tiuj kolektoj
         $datumbazo->petu(
                     "delete from " . PGKunteksto::leguTabelNomon('rel_artikloj_kolektoj') . " " .
                     "where artiklo={$this->_id}"
                  );

         // Se la artiklo havas etikedojn, forigu la ligojn inter ĝi kaj tiuj etikedoj.
         // Poste, etikedoj sen artikloj estas forigataj.
         $etikedoj = $this->leguEtikedojn();

         $datumbazo->petu(
                     "delete from " . PGKunteksto::leguTabelNomon('rel_artikloj_etikedoj') . " " .
                     "where artiklo={$this->_id}"
                  );

         foreach($etikedoj as $e) {
            if($e->leguNombronDaArtikloj() == 0)
               $e->forigu();
         }

         // Finfine forigu la artiklon mem
         $datumbazo->petu(
                     "delete from " . PGKunteksto::leguTabelNomon('artikloj') . " " .
                     "where id={$this->_id}"
                  );
      }

      function chuNeEkzistas() {
         return $id == -1;
      }

      function ghisdatigu() {
         global $datumbazo;
         if($this->_modifita) {
            $datoStampo = time();
            $datoKajHoro = date('Y-m-d H:i:s', $datoStampo);

            $datumbazo->petu(
               "update " . PGKunteksto::leguTabelNomon('artikloj') . " set " .
               "nomo=" . $datumbazo->aldonuCitilojn($this->_nomo) . "," .
               "prefikso=" . $datumbazo->aldonuCitilojn($this->_prefikso) . "," .
               "sufikso=" . $datumbazo->aldonuCitilojn($this->_sufikso) . "," .
               "titolo=" . $datumbazo->aldonuCitilojn($this->_titolo) . "," .
               "priskribo=" . $datumbazo->aldonuCitilojn($this->_priskribo) . "," .
               "rango={$this->_rango}," .
               "chuAlbumo=" . ($this->_chuAlbumo ? 1 : 0) . "," .
               "chuPrivata=" . ($this->_chuPrivata ? 1 : 0) . "," .
               "redaktita=" . $datumbazo->aldonuCitilojn($datoKajHoro) . " " .
               "where id={$this->_id}"
            );
            $this->_redaktita = $datoStampo;
            $this->_modifita = false;
         }
      }

      function leguIdentigilon() {
         return $this->_id;
      }

      function chuDosiero() {
         $this->sharguSeNecesa();
         return !$this->_chuLegosigno && !$this->_chuKolekto;
      }

      function chuLegosigno() {
         $this->sharguSeNecesa();
         return $this->_chuLegosigno;
      }

      function chuKolekto() {
         $this->sharguSeNecesa();
         return $this->_chuKolekto;
      }

      function chuAlbumo() {
         $this->sharguSeNecesa();
         return $this->_chuKolekto && $this->_chuAlbumo;
      }

      function ighuAlbumo($flago) {
         if($flago != $this->chuAlbumo())
            $this->_modifita = true;
         $this->_chuAlbumo = $flago;
      }

      function chuPrivata() {
         $this->sharguSeNecesa();
         return $this->_chuPrivata;
      }

      function ighuPrivata($flago) {
         if($flago != $this->chuPrivata())
            $this->_modifita = true;
         $this->_chuPrivata = $flago;
      }

      function leguNomon() {
         $this->sharguSeNecesa();
         return $this->_nomo;
      }

      function skribuNomon($nomo) {
         if($nomo != $this->leguNomon())
            $this->_modifita = true;
         $this->_nomo = $nomo;
      }

      function leguPrefikson() {
         $this->sharguSeNecesa();
         return $this->_prefikso;
      }

      function skribuPrefikson($prefikso) {
         if($prefikso != $this->leguPrefikson())
            $this->_modifita = true;
         $this->_prefikso = $prefikso;
      }

      function leguSufikson() {
         $this->sharguSeNecesa();
         return $this->_sufikso;
      }

      function skribuSufikson($sufikso) {
         if($sufikso != $this->leguSufikson())
            $this->_modifita = true;
         $this->_sufikso= $sufikso;
      }

      function leguKompletanNomon() {
         return $this->leguPrefikson() . $this->leguNomon() . $this->leguSufikson();
      }

      function leguTitolon() {
         $this->sharguSeNecesa();
         return $this->_titolo;
      }

      function skribuTitolon($titolo) {
         if($titolo != $this->leguTitolon())
            $this->_modifita = true;
         $this->_titolo = $titolo;
      }

      function leguPriskribon() {
         $this->sharguSeNecesa();
         return $this->_priskribo;
      }

      function skribuPriskribon($priskribo) {
         if($priskribo != $this->leguPriskribon())
            $this->_modifita = true;
         $this->_priskribo = $priskribo;
      }

      function leguRangon() {
         $this->sharguSeNecesa();
         return $this->_rango;
      }

      function skribuRangon($rango) {
         if($rango != $this->leguRangon())
            $this->_modifita = true;
         $this->_rango = $rango;
      }

      function leguKreanDaton() {
         $this->sharguSeNecesa();
         return $this->_kreita;
      }

      function leguModifanDaton() {
         $this->sharguSeNecesa();
         return $this->_redaktita;
      }

      function leguTiponKielCheno() {
         if($this->chuKolekto()) {
            if($this->chuAlbumo())
               return 'albumo';
            else
               return 'kolekto';
         }
         else if($this->chuLegosigno())
            return 'legosigno';
         else
            return 'dosiero';
      }

      function chuHavasEtikedon($etikedo) {
         global $datumbazo;
         $datumbazo->petu(
                     "select * " .
                     "from " . PGKunteksto::leguTabelNomon('rel_artikloj_etikedoj') . " " .
                     "where artiklo={$this->_id} and etikedo=" . $etikedo->leguIdentigilon()
                  );
         return $datumbazo->leguNombronDaRezultoj() > 0;
      }

      function chuEstasEnKolekto($kolekto) {
         global $datumbazo;
         $datumbazo->petu(
                     "select * " .
                     "from " . PGKunteksto::leguTabelNomon('rel_artikloj_kolektoj') . " " .
                     "where artiklo={$this->_id} and kolekto=" . $kolekto->leguIdentigilon()
                  );
         return $datumbazo->leguNombronDaRezultoj() > 0;
      }

      function leguEtikedojn() {
         global $datumbazo;
         $datumbazo->petu(
                     "select etikedo " .
                     "from " . PGKunteksto::leguTabelNomon('rel_artikloj_etikedoj') . " " .
                     "where artiklo={$this->_id}"
                  );

         $etikedoj = array();
         for($i=0; $i<$datumbazo->leguNombronDaRezultoj(); $i++)
            $etikedoj[] = PGFabriko::leguEtikedonKunIdentigilo($datumbazo->leguRezultonPorShlosiloEnIndico('etikedo', $i));
         return $etikedoj;
      }

      function aldonuEtikedon($etikedo) {
         global $datumbazo;
         $datumbazo->petu(
            "insert into " . PGKunteksto::leguTabelNomon('rel_artikloj_etikedoj') . " set " .
            "artiklo={$this->_id}," .
            "etikedo=" . $etikedo->leguIdentigilon()
         );
      }

      function foriguEtikedon($etikedo) {
         global $datumbazo;
         $datumbazo->petu(
            "delete from " . PGKunteksto::leguTabelNomon('rel_artikloj_etikedoj') . " " .
            "where artiklo={$this->_id} and etikedo=" . $etikedo->leguIdentigilon()
         );
      }

      function leguKolektojn() {
         global $datumbazo;
         $datumbazo->petu(
                     "select kolekto " .
                     "from " . PGKunteksto::leguTabelNomon('rel_artikloj_kolektoj') . " " .
                     "where artiklo={$this->_id}"
                  );

         $kolektoj = array();
         for($i=0; $i<$datumbazo->leguNombronDaRezultoj(); $i++)
            $kolektoj[] = PGFabriko::leguArtiklonKunIdentigilo($datumbazo->leguRezultonPorShlosiloEnIndico('kolekto', $i));
         return $kolektoj;
      }

      // static
      function leguChiujnArtiklojn($kunPrivataj=true) {
         global $datumbazo;
         if($kunPrivataj)
            $datumbazo->petu(
                        "select id " .
                        "from " . PGKunteksto::leguTabelNomon('artikloj') . " " .
                        "order by redaktita desc"
                     );
         else
            $datumbazo->petu(
                        "select id " .
                        "from " . PGKunteksto::leguTabelNomon('artikloj') . " " .
                        "where chuPrivata=0 " .
                        "order by redaktita desc"
                     );

         $artikloj = array();
         for($i=0; $i<$datumbazo->leguNombronDaRezultoj(); $i++)
            $artikloj[] = PGFabriko::leguArtiklonKunIdentigilo($datumbazo->leguRezultonPorShlosiloEnIndico('id', $i));
         return $artikloj;
      }

      // static
      function leguChiujnKolektojn($kunPrivataj=true) {
         global $datumbazo;
         if($kunPrivataj)
            $datumbazo->petu(
                        "select id " .
                        "from " . PGKunteksto::leguTabelNomon('artikloj') . " " .
                        "where chuKolekto=1"
                     );
         else
            $datumbazo->petu(
                        "select id " .
                        "from " . PGKunteksto::leguTabelNomon('artikloj') . " " .
                        "where chuKolekto=1 and chuPrivata=0"
                     );

         $artikloj = array();
         for($i=0; $i<$datumbazo->leguNombronDaRezultoj(); $i++)
            $artikloj[] = PGFabriko::leguArtiklonKunIdentigilo($datumbazo->leguRezultonPorShlosiloEnIndico('id', $i));
         return $artikloj;
      }

      // static
      function chuEkzistasArtiklonNomitan($nomo) {
         global $datumbazo;
         $datumbazo->petu(
                     "select id " .
                     "from " . PGKunteksto::leguTabelNomon('artikloj') . " " .
                     "where nomo=" . $datumbazo->aldonuCitilojn($nomo)
                  );
         return $datumbazo->leguNombronDaRezultoj() > 0;
      }

      function kielKolektoLeguGrandon() {
         global $datumbazo;
         $datumbazo->petu(
               "select artiklo from " . PGKunteksto::leguTabelNomon('rel_artikloj_kolektoj') . " " .
               "where kolekto={$this->_id}"
            );
         return $datumbazo->leguNombronDaRezultoj();
      }

      function kielKolektoAldonuArtiklon($artiklo) {
         global $datumbazo;
         $indico = $this->kielKolektoLeguGrandon();
         $datumbazo->petu(
            "insert into " . PGKunteksto::leguTabelNomon('rel_artikloj_kolektoj') . " set " .
            "indico=$indico," .
            "artiklo=" . $artiklo->leguIdentigilon() . "," .
            "kolekto={$this->_id}"
         );
      }

      function kielKolektoForiguArtiklon($artiklo) {
         global $datumbazo;

         // Legu la indicon de la unua fojo, kiam la artiklo aperas en la kolekto
         $indico = $this->kielKolektoLeguIndiconDeArtiklo($artiklo);

         // Forigu la ligon inter la artiklo kaj la kolekto
         $datumbazo->petu(
            "delete from " . PGKunteksto::leguTabelNomon('rel_artikloj_kolektoj') . " " .
            "where kolekto={$this->_id} and artiklo=" . $artiklo->leguIdentigilon()
         );

         // Ĝisdatigu la indicon de la sekvaj artikloj en la kolekto
         $datumbazo->petu(
            "update " . PGKunteksto::leguTabelNomon('rel_artikloj_kolektoj') . " set " .
            "indico=indico-1 " .
            "where kolekto={$this->_id} and indico>$indico"
         );
      }

      function kielKolektoLeguArtiklojn($kunPrivataj=true) {
         global $datumbazo;
         $datumbazo->petu(
            "select artiklo from " . PGKunteksto::leguTabelNomon('rel_artikloj_kolektoj') . " " .
            "where kolekto={$this->_id} " .
            "order by indico asc"
         );
         $artikloj = array();
         for($i=0;$i<$datumbazo->leguNombronDaRezultoj();$i++) {
            $artiklIdentigilo = $datumbazo->leguRezultonPorShlosiloEnIndico('artiklo', $i);
            $artikloj[] = PGFabriko::leguArtiklonKunIdentigilo($artiklIdentigilo);
         }

         if($kunPrivataj)
            return $artikloj;
         else {
            $selektitajArtikloj = array();
            for($i=0;$i<count($artikloj);$i++)
               if($kunPrivataj || !$artikloj[$i]->chuPrivata())
                  $selektitajArtikloj[] = $artikloj[$i];
            return $selektitajArtikloj;
         }
      }

      function kielKolektoLeguIndiconDeArtiklo($artiklo) {
         global $datumbazo;
         $datumbazo->petu(
            "select indico from " . PGKunteksto::leguTabelNomon('rel_artikloj_kolektoj') . " " .
            "where kolekto={$this->_id} and artiklo=" . $artiklo->leguIdentigilon()
         );
         return $datumbazo->leguRezultonPorShlosilo('indico');
      }

      function kielKolektoSkribuIndiconDeArtiklo($artiklo, $indico) {
         global $datumbazo;
         $datumbazo->petu(
            "update " . PGKunteksto::leguTabelNomon('rel_artikloj_kolektoj') . " set " .
            "indico=$indico " .
            "where kolekto={$this->_id} and artiklo=" . $artiklo->leguIdentigilon()
         );
      }

      function leguDosierTipon() {
         return PGDosiero::leguTiponPorNomo($this->leguNomon());
      }

      function foriguElTabelo($aro) {
         $rezulto = array();
         foreach($aro as $t) {
            if($t->leguIdentigilon() != $this->leguIdentigilon())
               $rezulto[] = $t;
         }
         return $rezulto;
      }
   }

   class PGArtikloNova extends PGArtiklo {

      function PGArtikloNova($nomo, $titolo, $priskribo, $rango, $chuKolekto, $chuLegosigno, $chuAlbumo, $chuPrivata) {
         global $datumbazo;

         $datoStampo = time();
         $datoKajHoro = date('Y-m-d H:i:s', $datoStampo);

         $datumbazo->petu(
            "insert into " . PGKunteksto::leguTabelNomon('artikloj') . " set " .
            "nomo=" . $datumbazo->aldonuCitilojn($nomo) . "," .
            "titolo=" . $datumbazo->aldonuCitilojn($titolo) . "," .
            "priskribo=" . $datumbazo->aldonuCitilojn($priskribo) . "," .
            "rango={$rango}," .
            "chuKolekto=" . ($chuKolekto ? 1 : 0) . "," .
            "chuLegosigno=" . ($chuLegosigno ? 1 : 0) . "," .
            "chuAlbumo=" . ($chuAlbumo ? 1 : 0) . "," .
            "chuPrivata=" . ($chuPrivata ? 1 : 0) . "," .
            "kreita=" . $datumbazo->aldonuCitilojn($datoKajHoro) . "," .
            "redaktita=" . $datumbazo->aldonuCitilojn($datoKajHoro)
         );

         $this->_id = mysql_insert_id();
         $this->_nomo = $nomo;
         $this->_prefikso = '';
         $this->_sufikso = '';
         $this->_titolo = $titolo;
         $this->_priskribo = $priskribo;
         $this->_rango = $rango;
         $this->_chuKolekto = $chuKolekto;
         $this->_chuLegosigno = $chuLegosigno;
         $this->_chuAlbumo = $chuAlbumo;
         $this->_chuPrivata = $chuPrivata;
         $this->_kreita = $datoStampo;
         $this->_redaktita = $datoStampo;

         $this->_modifita = false;
         $this->_shargita = true;
      }
   }

   class PGDosieroNova extends PGArtiklo {

      function PGDosieroNova($dosiero, $titolo, $priskribo, $rango, $chuPrivata) {
         global $datumbazo;

         $datoStampo = time();
         $datoKajHoro = date('Y-m-d H:i:s', $datoStampo);

         $datumbazo->petu(
            "insert into " . PGKunteksto::leguTabelNomon('artikloj') . " set " .
            "nomo=" . $datumbazo->aldonuCitilojn($dosiero->leguNomon()) . "," .
            "prefikso=" . $datumbazo->aldonuCitilojn($dosiero->leguPrefikson()) . "," .
            "sufikso=" . $datumbazo->aldonuCitilojn($dosiero->leguSufikson()) . "," .
            "titolo=" . $datumbazo->aldonuCitilojn($titolo) . "," .
            "priskribo=" . $datumbazo->aldonuCitilojn($priskribo) . "," .
            "rango={$rango}," .
            "chuKolekto=0," .
            "chuLegosigno=0," .
            "chuAlbumo=0," .
            "chuPrivata=" . ($chuPrivata ? 1 : 0) . "," .
            "kreita=" . $datumbazo->aldonuCitilojn($datoKajHoro) . "," .
            "redaktita=" . $datumbazo->aldonuCitilojn($datoKajHoro)
         );

         $this->_id = mysql_insert_id();
         $this->_nomo = $dosiero->leguNomon();
         $this->_prefikso = $dosiero->leguPrefikson();
         $this->_sufikso = $dosiero->leguSufikson();
         $this->_titolo = $titolo;
         $this->_priskribo = $priskribo;
         $this->_rango = $rango;
         $this->_chuKolekto = false;
         $this->_chuLegosigno = false;
         $this->_chuAlbumo = false;
         $this->_chuPrivata = $chuPrivata;
         $this->_kreita = $datoStampo;
         $this->_redaktita = $datoStampo;

         $this->_modifita = false;
         $this->_shargita = true;
      }
   }

   class PGArtikloKunId extends PGArtiklo {

      function PGArtikloKunId($id) {
         $this->_id = $id;

         $this->_modifita = false;
         $this->_shargita = false;
      }
   }

   class PGArtikloKunNomo extends PGArtiklo {

      function PGArtikloKunNomo($nomo) {
         global $datumbazo;
         $datumbazo->petu(
                     "select id " .
                     "from " . PGKunteksto::leguTabelNomon('artikloj') . " " .
                     "where nomo=" . $datumbazo->aldonuCitilojn($nomo)
                  );

         if($datumbazo->leguNombronDaRezultoj() > 0)
            $this->_id = $datumbazo->leguRezultonPorShlosilo('id');
         else
            $this->_id = -1;

         $this->_modifita = false;
         $this->_shargita = false;
      }
   }

?>
