<?php
/* Ĉi tiu dosiero estas parto de Pâturage
 * 
 * Copyright (C) 2007 - Guillaume Savaton <llumeao@gmail.com>
 * 
 * Pâturage  estas libera programo;  vi  povas  ĝin  pludistribui  kaj/aŭ
 * modifi je la  kondiĉoj de la GNUa Ĝenerala Publika Permesilo, eldonita
 * de «Free Software Foundation», laŭ la versio 2 de tiu Permesilo aŭ, se
 * vi preferas, ajna posta versio.
 * 
 * Ni distribuas  ĉi tiun  programon esperante  ke ĝi estos  utila, tamen
 * SEN IA AJN GARANTIO,  i.a. sen la implica garantio pri SURMERKATIGEBLO
 * aŭ  TAŬGECO POR IU KONKRETA CELO. Pliajn  detalojn  vidu  en  la  GNUa
 * Ĝenerala Publika Permesilo.
 * 
 * Ekzemplero  de  la  GNUa  Ĝenerala Publika    Permesilo   devas   esti
 * liverita al vi kun ĉi tiu programo; ricevis, turnu vin al
 * 
 * Free Software Foundation
 * 51 Franklin Street, Fifth Floor
 * Boston, MA 02110-1301, USA
 * ------------------------------------------------------------------- */
?>
<?php

   require_once('agordoj/dosiertipoj.php');
   require_once('klasoj/artiklo.php');

   class PGDosiero {

      var $_nomo;
      var $_prefikso;

      function PGDosiero($nomo) {
         $this->_nomo = $nomo;
         $this->konstruuPrefikson();
      }

      // static
      function leguTiponPorNomo($nomo) {
         global $dosierTipoj;
         $finajho = PGDosiero::leguFinajhonEnNomo($nomo);
         if(array_key_exists($finajho, $dosierTipoj))
            return $dosierTipoj[$finajho]['tipo'];
         else
            return 'dosiero';
      }

      // static
      function leguFinajhonEnNomo($nomo) {
         return strtolower(substr($nomo, strrpos($nomo, '.')+1));
      }

      function konstruuPrefikson() {
         $stampo = date('Ymd-His-');
         $this->_prefikso = $stampo;
         $nombrilo = 1;
         $finaNomo = $this->_prefikso . $this->_nomo;

         while(PGArtiklo::chuEkzistasArtiklonNomitan($finaNomo)) {
            $this->_prefikso = "$stampo$nombrilo-";
            $finaNomo = $this->_prefikso . $this->_nomo;
            $nombrilo++ ;
         }
      }

      function leguNomon() {
         return $this->_nomo;
      }

      function leguPrefikson() {
         return $this->_prefikso;
      }

      function leguFinajhon() {
         return PGDosiero::leguFinajhonEnNomo($this->_nomo);
      }

      function leguTipon() {
         return PGDosiero::leguTiponPorNomo($this->_nomo);
      }

      function leguSufikson() {
         global $dosierTipoj;
         $finajho = $dosierTipoj[$this->leguFinajhon()]['sufikso'];
         if($finajho == '')
            return '';
         else
            return ".$finajho";
      }

      function chuVidigebla() {
         global $dosierTipoj;
         return $dosierTipoj[$this->leguFinajhon()]['vidigebla'];
      }

      function leguKompletanNomon() {
         return $this->_prefikso . $this->_nomo . $this->leguSufikson();
      }
   }

?>
