<?php
/* Ĉi tiu dosiero estas parto de Pâturage
 * 
 * Copyright (C) 2007 - Guillaume Savaton <llumeao@gmail.com>
 * 
 * Pâturage  estas libera programo;  vi  povas  ĝin  pludistribui  kaj/aŭ
 * modifi je la  kondiĉoj de la GNUa Ĝenerala Publika Permesilo, eldonita
 * de «Free Software Foundation», laŭ la versio 2 de tiu Permesilo aŭ, se
 * vi preferas, ajna posta versio.
 * 
 * Ni distribuas  ĉi tiun  programon esperante  ke ĝi estos  utila, tamen
 * SEN IA AJN GARANTIO,  i.a. sen la implica garantio pri SURMERKATIGEBLO
 * aŭ  TAŬGECO POR IU KONKRETA CELO. Pliajn  detalojn  vidu  en  la  GNUa
 * Ĝenerala Publika Permesilo.
 * 
 * Ekzemplero  de  la  GNUa  Ĝenerala Publika    Permesilo   devas   esti
 * liverita al vi kun ĉi tiu programo; ricevis, turnu vin al
 * 
 * Free Software Foundation
 * 51 Franklin Street, Fifth Floor
 * Boston, MA 02110-1301, USA
 * ------------------------------------------------------------------- */
?>
<?php
   require_once('klasoj/vidajho.php');
   require_once('klasoj/etikedo.php');
   require_once('klasoj/aranghisto.php');
   require_once('klasoj/fabriko.php');

   class PGEtikedaVidajho extends PGVidajho {

      function vidiguEtikedaron($formularo=false) {
         global $kunteksto;

         // Akiru ĉiujn etikedojn
         $chiujEtikedoj = PGEtikedo::leguChiujnEtikedojn();

         // Kalkulu la statistikojn por ĉiuj etikedoj
         $minNombro = $maksNombro = $sumo = 0;
         foreach($chiujEtikedoj as $t) {
            $nombro = $t->leguNombronDaArtikloj();
            if($minNombro == 0 || $nombro < $minNombro)
               $minNombro = $nombro;
            if($nombro > $maksNombro)
               $maksNombro = $nombro;
            $sumo += $nombro;
            $nombrojDaArtiklojProEtikedo[$t->leguIdentigilon()] = $nombro;
         }

         if(count($chiujEtikedoj) > 0)
            $mezNombro = $sumo / count($chiujEtikedoj);

         // Kalkulu la grandon de ĉiuj etikedoj lau la nombroj de artikloj
         foreach($chiujEtikedoj as $t) {
            if($maksNombro == $minNombro)
               $etikedGrandoj[$t->leguIdentigilon()] = 100;
            else {
               $nunaGrando = round(($nombrojDaArtiklojProEtikedo[$t->leguIdentigilon()] - $mezNombro) * 100 / ($maksNombro - $minNombro) + 100);
               if($nunaGrando < $kunteksto->leguAgordonPriMinimumaTiparaGradoEnEtikedaro())
                  $etikedGrandoj[$t->leguIdentigilon()] = $kunteksto->leguAgordonPriMinimumaTiparaGradoEnEtikedaro();
               else if($nunaGrando > $kunteksto->leguAgordonPriMaksimumaTiparaGradoEnEtikedaro())
                  $etikedGrandoj[$t->leguIdentigilon()] = $kunteksto->leguAgordonPriMaksimumaTiparaGradoEnEtikedaro();
               else
                  $etikedGrandoj[$t->leguIdentigilon()] = $nunaGrando;
            }
         }

         // Legu la identigilojn de la nune selektitaj etikedoj
         $argEtikedIdentigiloj = $kunteksto->leguArgumentonPriEtikedIdentigiloj();

         if(!$formularo)
            // En la foliumilo de Pâturage, vidigu specialan etikedon por selekti ĉiujn artiklojn
            PGAranghisto::vidiguTekstanLigilon(
                  '[' . $kunteksto->leguTradukon('Ĉiuj') . ']',
                  $kunteksto->leguURLonAlFoliumaVidajho(),
                  $kunteksto->leguTradukon('Selektu ĉiujn artiklojn')
               );
         else {
            // En la redaktila formularo, inkluzivu skripton por mastrumi la etikedan kampon
            PGAranghisto::inkluzivuSkripton('skriptoj/etikedaro.js');
         }
         
         // Vidigu la etikedaron
         $komenco = true;
         foreach($chiujEtikedoj as $t) {
            $etikedIdentigilo = $t->leguIdentigilon();
            if(!$formularo) {
               // En la foliumilo, por ĉiu etikedo, kreu ligon por selekti/malselekti ĝin

               // Specifu la klason kaj la helpilon de la ligo,
               // laŭ la selektita stato de la etikedo
               if(in_array($etikedIdentigilo, $argEtikedIdentigiloj)) {
                  $klaso = 'pg-etikedo-selektita';
                  $helpilo = $kunteksto->leguTradukon('Malselektu tiun etikedon');
               }
               else {
                  $klaso = 'pg-etikedo-neselektita';
                  $helpilo = $kunteksto->leguTradukon('Selektu tiun etikedon');
               }

               // Specifu la URLon de la ligo por aldoni/forigi etikedon
               // al la jam-selektitaj etikedoj
               if($kunteksto->chuEkzistasArgumentonPriEtikedoj()) {
                  if(in_array($etikedIdentigilo, $argEtikedIdentigiloj)) {
                     $etikedCheno = '';
                     foreach($argEtikedIdentigiloj as $i) {
                        if($i != $etikedIdentigilo) {
                           if($etikedCheno != '')
                              $etikedCheno .= ',';
                           $etikedCheno .= $i;
                        }
                     }
                  }
                  else
                     $etikedCheno = $kunteksto->leguArgumentonPriEtikedIdentigilojKielCheno() . ",$etikedIdentigilo";
               }
               else
                  $etikedCheno = "$etikedIdentigilo";
   
               $href = $kunteksto->leguURLonAlFoliumaVidajho($etikedCheno);
            }
            else {
               // En la redaktila formularo, kreu ligon al ĝavoskript-funkcio
               $klaso = 'pg-etikedo-neselektita';
               $helpilo = $kunteksto->leguTradukon('Aldonu/forigu tiun etikedon');
               $href = "javascript:aldonuAuForiguEtikedon('" . $t->leguNomon() . "')";
            }
            
            // Vidigu la spacilon
            if(!$komenco)
               PGAranghisto::vidiguTekston(', ', 'pg-etikeda-spacilo');
            else
               $komenco = false;

            // Vidigu la ligilon
            PGAranghisto::vidiguTekstanLigilon(
                  $t->leguNomon(),
                  $href,
                  $helpilo,
                  $klaso,
                  "font-size: {$etikedGrandoj[$etikedIdentigilo]}%;"
               );
         }
      }
   }
?>
