<?php
/* Ĉi tiu dosiero estas parto de Pâturage
 * 
 * Copyright (C) 2007 - Guillaume Savaton <llumeao@gmail.com>
 * 
 * Pâturage  estas libera programo;  vi  povas  ĝin  pludistribui  kaj/aŭ
 * modifi je la  kondiĉoj de la GNUa Ĝenerala Publika Permesilo, eldonita
 * de «Free Software Foundation», laŭ la versio 2 de tiu Permesilo aŭ, se
 * vi preferas, ajna posta versio.
 * 
 * Ni distribuas  ĉi tiun  programon esperante  ke ĝi estos  utila, tamen
 * SEN IA AJN GARANTIO,  i.a. sen la implica garantio pri SURMERKATIGEBLO
 * aŭ  TAŬGECO POR IU KONKRETA CELO. Pliajn  detalojn  vidu  en  la  GNUa
 * Ĝenerala Publika Permesilo.
 * 
 * Ekzemplero  de  la  GNUa  Ĝenerala Publika    Permesilo   devas   esti
 * liverita al vi kun ĉi tiu programo; ricevis, turnu vin al
 * 
 * Free Software Foundation
 * 51 Franklin Street, Fifth Floor
 * Boston, MA 02110-1301, USA
 * ------------------------------------------------------------------- */
?>
<?php

   require_once('klasoj/datumbazo.php');
   require_once('klasoj/fabriko.php');

   /// @todo Difinu kampon pri la nombro da artikoloj, kiuj havas specifan etikedon
   class PGEtikedo {

      var $_id;
      var $_nomo;

      var $_modifita;
      var $_shargita;
      var $_nova;

      // private
      function sharguSeNecesa() {
         global $datumbazo;
         if($this->_shargita)
            return;

         $datumbazo->petu(
                     "select * " .
                     "from " . PGKunteksto::leguTabelNomon('etikedoj') . " " .
                     "where id={$this->_id}"
                  );

         $this->_nomo = $datumbazo->leguRezultonPorShlosilo('nomo');

         $this->_shargita = true;
      }

      function forigu() {
         global $datumbazo;
         $datumbazo->petu(
            "delete from " . PGKunteksto::leguTabelNomon('etikedoj') . " " .
            "where id={$this->_id}"
         );
      }

      function chuNeEkzistas() {
         return $id == -1;
      }

      function ghisdatigu() {
         global $datumbazo;
         if($this->_modifita) {
            $datumbazo->petu(
               "update " . PGKunteksto::leguTabelNomon('etikedoj') . " set " .
               "nomo=" . $datumbazo->aldonuCitilojn($this->_nomo) . "," .
               "where id={$this->_id}"
            );
            $this->_modifita = false;
         }
      }

      function leguIdentigilon() {
         return $this->_id;
      }

      function leguNomon() {
         $this->sharguSeNecesa();
         return $this->_nomo;
      }

      function skribuNomon($nomo) {
         $this->sharguSeNecesa();
         if($nomo != $this->_nomo)
            $this->_modifita = true;
         $this->_nomo = $nomo;
      }

      function chuNova() {
         return $this->_nova;
      }

      function leguNombronDaArtikloj() {
         global $datumbazo;
         $datumbazo->petu(
                     "select artiklo " .
                     "from " . PGKunteksto::leguTabelNomon('rel_artikloj_etikedoj') . " " .
                     "where etikedo={$this->_id}"
                  );

         return $datumbazo->leguNombronDaRezultoj();
      }

      function leguArtiklojn() {
         global $datumbazo;
         $datumbazo->petu(
                     "select artiklo " .
                     "from " . PGKunteksto::leguTabelNomon('rel_artikloj_etikedoj') . " " .
                     "where etikedo={$this->_id}"
                  );

         $artikloj = array();
         for($i=0; $i<$datumbazo->leguNombronDaRezultoj(); $i++)
            $artikloj[] = PGFabriko::leguArtiklonKunIdentigilo($datumbazo->leguRezultonPorShlosiloEnIndico('artiklo', $i));
         return $artikloj;
      }

      function selektuArtiklojn($listoDeArtikloj) {
         global $datumbazo;
         $datumbazo->petu(
                     "select artiklo " .
                     "from " . PGKunteksto::leguTabelNomon('rel_artikloj_etikedoj') . " " .
                     "where etikedo={$this->_id}"
                  );

         $artiklIdentigiloj = array();
         for($i=0; $i<$datumbazo->leguNombronDaRezultoj(); $i++)
            $artiklIdentigiloj[] = $datumbazo->leguRezultonPorShlosiloEnIndico('artiklo', $i);

         $artikloj = array();
         foreach($listoDeArtikloj as $e)
            if(in_array($e->leguIdentigilon(), $artiklIdentigiloj))
               $artikloj[] = $e;

         return $artikloj;
      }

      // static
      function leguChiujnEtikedojn() {
         global $datumbazo;
         $datumbazo->petu(
                     "select id " .
                     "from " . PGKunteksto::leguTabelNomon('etikedoj') . " order by nomo asc"
                  );

         $etikedoj = array();
         for($i=0; $i<$datumbazo->leguNombronDaRezultoj(); $i++)
            $etikedoj[] = PGFabriko::leguEtikedonKunIdentigilo($datumbazo->leguRezultonPorShlosiloEnIndico('id', $i));
         return $etikedoj;
      }

      function foriguElTabelo($aro) {
         $rezulto = array();
         foreach($aro as $t) {
            if($t->leguIdentigilon() != $this->leguIdentigilon())
               $rezulto[] = $t;
         }
         return $rezulto;
      }
   }

   class PGEtikedoKunId extends PGEtikedo {

      function PGEtikedoKunId($id) {
         $this->_id = $id;

         $this->_modifita = false;
         $this->_shargita = false;
      }
   }

   class PGEtikedoKunNomo extends PGEtikedo {

      function PGEtikedoKunNomo($nomo) {
         global $datumbazo;

         // Trovu etikedon kun tiu nomo en la datumbazo
         $datumbazo->petu(
                     "select id " .
                     "from " . PGKunteksto::leguTabelNomon('etikedoj') . " " .
                     "where nomo=". $datumbazo->aldonuCitilojn($nomo)
                  );
         
         if($datumbazo->leguNombronDaRezultoj() == 0) {
            // Neniu etikedo troveblas: kreu novan
            $datumbazo->petu(
               "insert into " . PGKunteksto::leguTabelNomon('etikedoj') . " set " .
               "nomo=" . $datumbazo->aldonuCitilojn($nomo)
            );

            $this->_id = mysql_insert_id();
            $this->_nomo = $nomo;

            $this->_nova = true;
            $this->_shargita = true;
         }
         else {
            $this->_id = $datumbazo->leguRezultonPorShlosilo('id');

            $this->_shargita = false;
         }

         $this->_modifita = false;
      }
   }

?>
