<?php
/* Ĉi tiu dosiero estas parto de Pâturage
 * 
 * Copyright (C) 2007 - Guillaume Savaton <llumeao@gmail.com>
 * 
 * Pâturage  estas libera programo;  vi  povas  ĝin  pludistribui  kaj/aŭ
 * modifi je la  kondiĉoj de la GNUa Ĝenerala Publika Permesilo, eldonita
 * de «Free Software Foundation», laŭ la versio 2 de tiu Permesilo aŭ, se
 * vi preferas, ajna posta versio.
 * 
 * Ni distribuas  ĉi tiun  programon esperante  ke ĝi estos  utila, tamen
 * SEN IA AJN GARANTIO,  i.a. sen la implica garantio pri SURMERKATIGEBLO
 * aŭ  TAŬGECO POR IU KONKRETA CELO. Pliajn  detalojn  vidu  en  la  GNUa
 * Ĝenerala Publika Permesilo.
 * 
 * Ekzemplero  de  la  GNUa  Ĝenerala Publika    Permesilo   devas   esti
 * liverita al vi kun ĉi tiu programo; ricevis, turnu vin al
 * 
 * Free Software Foundation
 * 51 Franklin Street, Fifth Floor
 * Boston, MA 02110-1301, USA
 * ------------------------------------------------------------------- */
?>
<?php
   require_once('klasoj/artiklo.php');
   require_once('klasoj/etikedo.php');
   require_once('klasoj/dosiera-vidajho.php');
   require_once('klasoj/lumbilda-vidajho.php');
   require_once('klasoj/legosigna-vidajho.php');
   require_once('klasoj/kolekta-vidajho.php');
   require_once('klasoj/albuma-vidajho.php');

   $artiklojEnFabriko = array();
   $etikedojEnFabriko = array();
   $vidajhojEnFabriko = array();

   class PGFabriko {

      function leguArtiklonKunIdentigilo($id) {
         global $artiklojEnFabriko;
         if(!array_key_exists($id, $artiklojEnFabriko))
            $artiklojEnFabriko[$id] = new PGArtikloKunId($id);
         return $artiklojEnFabriko[$id];
      }

      function leguArtiklonKunNomo($nomo) {
         global $artiklojEnFabriko;
         foreach($artiklojEnFabriko as $e)
            if($e->leguNomon() == $nomo)
               return $e;
         $e = new PGArtikloKunNomo($nomo);
         $artiklojEnFabriko[$e->leguIdentigilon()] = $e;
         return $e;
      }

      function leguEtikedonKunIdentigilo($id) {
         global $etikedojEnFabriko;
         if(!array_key_exists($id, $etikedojEnFabriko))
            $etikedojEnFabriko[$id] = new PGEtikedoKunId($id);
         return $etikedojEnFabriko[$id];
      }

      function leguEtikedonKunNomo($nomo) {
         global $etikedojEnFabriko;
         foreach($etikedojEnFabriko as $t)
            if($t->leguNomon() == $nomo)
               return $t;
         $t = new PGEtikedoKunNomo($nomo);
         $etikedojEnFabriko[$t->leguIdentigilon()] = $t;
         return $t;
      }

      function leguVidajhonPorArtiklo($artiklo) {
         global $vidajhojEnFabriko;
         if(!array_key_exists($artiklo->leguIdentigilon(), $vidajhojEnFabriko)) {
            switch($artiklo->leguTiponKielCheno()) {

               case 'albumo':
                  $vidajhojEnFabriko[$artiklo->leguIdentigilon()] = new PGAlbumaVidajho($artiklo);
                  break;

               case 'kolekto':
                  $vidajhojEnFabriko[$artiklo->leguIdentigilon()] = new PGKolektaVidajho($artiklo);
                  break;

               case 'legosigno':
                  $vidajhojEnFabriko[$artiklo->leguIdentigilon()] = new PGLegosignaVidajho($artiklo);
                  break;

               case 'dosiero':
               default:
                  $vidajhojEnFabriko[$artiklo->leguIdentigilon()] = new PGDosieraVidajho($artiklo);
            }
         }
         return $vidajhojEnFabriko[$artiklo->leguIdentigilon()];
      }

      function leguLumbildanVidajhonPorArtiklo($artiklo) {
         return new PGLumbildaVidajho($artiklo);
      }
   }
?>
