<?php
/* Ĉi tiu dosiero estas parto de Pâturage
 * 
 * Copyright (C) 2007 - Guillaume Savaton <llumeao@gmail.com>
 * 
 * Pâturage  estas libera programo;  vi  povas  ĝin  pludistribui  kaj/aŭ
 * modifi je la  kondiĉoj de la GNUa Ĝenerala Publika Permesilo, eldonita
 * de «Free Software Foundation», laŭ la versio 2 de tiu Permesilo aŭ, se
 * vi preferas, ajna posta versio.
 * 
 * Ni distribuas  ĉi tiun  programon esperante  ke ĝi estos  utila, tamen
 * SEN IA AJN GARANTIO,  i.a. sen la implica garantio pri SURMERKATIGEBLO
 * aŭ  TAŬGECO POR IU KONKRETA CELO. Pliajn  detalojn  vidu  en  la  GNUa
 * Ĝenerala Publika Permesilo.
 * 
 * Ekzemplero  de  la  GNUa  Ĝenerala Publika    Permesilo   devas   esti
 * liverita al vi kun ĉi tiu programo; ricevis, turnu vin al
 * 
 * Free Software Foundation
 * 51 Franklin Street, Fifth Floor
 * Boston, MA 02110-1301, USA
 * ------------------------------------------------------------------- */
?>
<?php
   require_once('agordoj/agordoj.php');
   require_once('klasoj/fabriko.php');
   require_once('klasoj/etikedo.php');
   require_once('klasoj/artiklo.php');
   include_once('lingvoj/' . PGKunteksto::leguAgordonPriLingvo() . '.php');
   include_once(PGKunteksto::leguDosierIndikonAlShablonujo() . '/lingvoj/' . PGKunteksto::leguAgordonPriLingvo() . '.php');

   class PGKunteksto {

      var $_paghTipo;
      var $_ensaluto;
      var $_graveco;
      var $_mesagho;

      function PGKunteksto($tipo) {
         global $agordoj;
         $this->_paghTipo = $tipo;
         switch($tipo) {
            case 'foliumilo':
               setCookie('foliumilo', 'etikedoj=' . PGKunteksto::leguArgumentonPriEtikedIdentigilojKielCheno());
               setCookie('artiklo', 'NENIO');
               break;
            case 'vidajho':
               setCookie('artiklo', 'artiklo=' . PGKunteksto::leguArgumentonPriArtiklIdentigilo());
               break;
         }

         if(array_key_exists('ago', $_GET)) {
            if($_GET['ago'] == 'ensalutu') {
               if($_POST['pasvorto'] == $agordoj['paturage uzanta pasvorto'])
                  $this->_ensaluto = 'uzanto';
               else if($_POST['pasvorto'] == $agordoj['paturage administra pasvorto'])
                  $this->_ensaluto = 'administristo';
               else
                  $this->_ensaluto = 'gasto';
               setCookie('ensalutu', md5($_POST['pasvorto']), time()+$agordoj['vivdauro de kuketoj']);
            }
            else if($_GET['ago'] == 'elsalutu') {
               $this->_ensaluto = 'gasto';
               setCookie('ensalutu', 'gasto');
            }
         }
         else if(array_key_exists('ensalutu', $_COOKIE)) {
            if($_COOKIE['ensalutu'] == md5($agordoj['paturage administra pasvorto']))
               $this->_ensaluto = 'administristo';
            else if($_COOKIE['ensalutu'] == md5($agordoj['paturage uzanta pasvorto']))
               $this->_ensaluto = 'uzanto';
            else
               $this->_ensaluto = 'gasto';
         }
         else
            $this->_ensaluto = 'gasto';

         if(array_key_exists('mesagho', $_GET)) {
            switch($_GET['mesagho']) {
               case 'eadmin':
                  $this->_mesagho = $this->leguTradukon('Bonvole ensalutu kiel administristo');
                  $this->_graveco = 'eraro';
                  break;

               case 'epriv':
                  $this->_mesagho = $this->leguTradukon('Privataj artikloj estas videblaj nur de ensalutintaj uzantoj');
                  $this->_graveco = 'eraro';
                  break;

               case 'isuks':
                  $this->_mesagho = $this->leguTradukon('Operacio sukcesis');
                  $this->_graveco = 'informo';
                  break;

               default:
                  $this->_mesagho = '';
                  $this->_graveco = 'NENIO';
            }
         }
         else {
            $this->_mesagho = '';
            $this->_graveco = 'NENIO';
         }
      }

      function chuEnLumbildo() {
         return $this->_paghTipo == 'lumbildo';
      }

      function leguArgumentonPriEtikedoj() {
         $etikedIdentigiloj = PGKunteksto::leguArgumentonPriEtikedIdentigiloj();
         $etikedoj = array();
         foreach($etikedIdentigiloj as $i) {
            $etikedoj[$i] = PGFabriko::leguEtikedonKunIdentigilo($i);
         }
         return $etikedoj;
      }

      function leguArgumentonPriEtikedIdentigiloj() {
         $etikedIdentigiloj = explode(',', $_GET['etikedoj']);
         $rezulto = array();
         foreach($etikedIdentigiloj as $id)
            if(is_numeric($id))
               $rezulto[] = intval($id, 10);
         return $rezulto;
      }

      function chuEkzistasArgumentonPriEtikedoj() {
         return array_key_exists('etikedoj', $_GET);
      }

      function leguArgumentonPriEtikedIdentigilojKielCheno() {
         return $_GET['etikedoj'];
      }

      function leguArgumentonPriArtiklIdentigilo() {
         return $_GET['artiklo'];
      }

      function leguArgumentonPriArtiklo() {
         return PGFabriko::leguArtiklonKunIdentigilo($_GET['artiklo']);
      }

      function leguArgumentonPriFarendaRedaktOperacio() {
         if(array_key_exists('kreu', $_GET))
            return 'kreu';
         else if(array_key_exists('redaktu', $_GET))
            return 'redaktu';
         else
            return 'NENIO';
      }

      function leguGraveconDeMesagho() {
         return $this->_graveco;
      }

      function leguTekstonDeMesagho() {
         return $this->_mesagho;
      }

      function skribuMesaghon($graveco, $teksto) {
         $this->_graveco = $graveco;
         $this->_mesagho = $teksto;
      }

      function leguKamponPriTitolo() {
         return $_POST['titolo'];
      }

      function leguKamponPriPriskribo() {
         return $_POST['priskribo'];
      }

      function leguKamponPriChuAlbumo() {
         return $_POST['chuAlbumo'] == 'on';
      }

      function leguKamponPriChuPrivata() {
         return $_POST['chuPrivata'] == 'on';
      }

      function leguKamponPriEtikedoj() {
         $etikedoj = array();
         $etikedNomoj = explode(",", trim($_POST['etikedoj']));
         foreach($etikedNomoj as $t) {
            $nunaEtikedNomo = trim($t);
            if($nunaEtikedNomo!='')
               $etikedoj[] = PGFabriko::leguEtikedonKunNomo($nunaEtikedNomo);
         }
         return $etikedoj;
      }

      function leguKamponPriRango() {
         return $_POST['rango'];
      }

      function leguArgumentonPriKreendaTipoDeArtiklo() {
         if(array_key_exists('kreu', $_GET))
            return $_GET['kreu'];
         else
            return 'NENIO';
      }

      function leguArgumentonPriForigendaArtiklo() {
         if(array_key_exists('forigu', $_GET))
            return PGFabriko::leguArtiklonKunIdentigilo($_GET['forigu']);
         else
            return 'NENIO';
      }

      function leguArgumentonPriRedaktendaArtiklo() {
         return PGFabriko::leguArtiklonKunIdentigilo($_GET['redaktu']);
      }

      function leguKamponPriNomo() {
         return trim($_POST['nomo']);
      }

      function leguKamponPriNomoDeAlshutitaDosiero() {
         if($_FILES['alshutilo']['error'] != UPLOAD_ERR_NO_FILE)
            return $_FILES['alshutilo']['name'];
         else
            return '';
      }

      function leguKamponPriNomoDePortempaDosiero() {
         if($_FILES['alshutilo']['error'] != UPLOAD_ERR_NO_FILE)
            return $_FILES['alshutilo']['tmp_name'];
         else
            return '';
      }

      function leguKamponPriKolektoj() {
         $kolektoj = array();
         if(array_key_exists('kolektoj', $_POST)) {
            foreach($_POST['kolektoj'] as $c => $v)
               if($v == 'on')
                  $kolektoj[] = PGFabriko::leguArtiklonKunIdentigilo($c);
         }
         return $kolektoj;
      }

      function leguKamponPriOrdo() {
         return $_POST['ordo'];
      }

      function leguAgordonPriChefaTitolo() {
         global $agordoj;
         return $agordoj['chefa titolo'];
      }

      function leguAgordonPriLingvo() {
         global $agordoj;
         return $agordoj['lingvo'];
      }

      function leguAgordonPriKodosistemoEnHTML() {
         global $kodosistemo;
         return $kodosistemo['html'];
      }

      function leguAgordonPriKodosistemoEnDatumbazo() {
         global $kodosistemo;
         return $kodosistemo['mysql'];
      }

      function leguAgordonPriOrdigoEnDatumbazo() {
         global $kodosistemo;
         return $kodosistemo['ordigo'];
      }

      function leguAgordonPriNombroDaMiniaturojEnAlbumoj() {
         global $agordoj;
         return $agordoj['nombro da miniaturoj en albumoj'];
      }

      function leguAgordonPriMinimumaTiparaGradoEnEtikedaro() {
         global $agordoj;
         return $agordoj['minimuma grandeco de etikedoj'];
      }

      function leguAgordonPriMaksimumaTiparaGradoEnEtikedaro() {
         global $agordoj;
         return $agordoj['maksimuma grandeco de etikedoj'];
      }

      function leguAgordonPriMySQLServilo() {
         global $agordoj;
         return $agordoj['mysql servilo'];
      }

      function leguAgordonPriMySQLUzanto() {
         global $agordoj;
         return $agordoj['mysql uzanto'];
      }

      function leguAgordonPriMySQLPasvorto() {
         global $agordoj;
         return $agordoj['mysql pasvorto'];
      }

      function leguAgordonPriMySQLDatumbazo() {
         global $agordoj;
         return $agordoj['mysql datumbazo'];
      }

      function leguAgordonPriLarghoDeBildoj() {
         global $agordoj;
         return $agordoj['largho de bildoj'];
      }

      function leguAgordonPriAltoDeBildoj() {
         global $agordoj;
         return $agordoj['alto de bildoj'];
      }

      function leguAgordonPriLarghoDeMiniaturoj() {
         global $agordoj;
         return $agordoj['largho de miniaturoj'];
      }

      function leguAgordonPriAltoDeMiniaturoj() {
         global $agordoj;
         return $agordoj['alto de miniaturoj'];
      }

      function leguAgordonPriNombroDaRangoj() {
         global $agordoj;
         return $agordoj['nombro da rang-niveloj'];
      }

      function leguTabelNomon($nomo) {
         global $agordoj;
         return $agordoj['mysql tabelprefikso'] . '_' . $nomo;
      }

      function leguDosierIndikonAlShablonujo() {
         global $agordoj;
         return "shablonoj/{$agordoj['shablono']}";
      }

      function leguDosierIndikonAlShablono($nomo) {
         return PGKunteksto::leguDosierIndikonAlShablonujo() . "/$nomo.php";
      }

      function leguDosierIndikonAlPiktogramKatalogo() {
         return PGKunteksto::leguDosierIndikonAlShablonujo() . '/piktogramoj.php';
      }

      function leguDosierIndikonAlPiktogramujo() {
         global $agordoj;
         return "shablonoj/{$agordoj['shablono']}/piktogramoj";
      }

      function leguDosierIndikonAlStilFolio() {
         global $agordoj;
         return "shablonoj/{$agordoj['shablono']}/stiloj.css";
      }

      function leguDosierIndikonAlPaturage() {
         return substr(__FILE__, 0, strlen(__FILE__) - strlen('/klasoj/kunteksto.php'));
      }

      function leguDosierIndikonAlDosierDeponejo() {
         global $agordoj;
         return PGKunteksto::leguDosierIndikonAlPaturage() . "/{$agordoj['pado al la dosierdeponejo']}";
      }

      function leguDosierIndikonAlLaboraDosierujo() {
         return PGKunteksto::leguDosierIndikonAlPaturage() . "/bildoj";
      }

      function leguURLonAlDosiero($dosiero) {
         global $agordoj;
         return "http://{$_SERVER['HTTP_HOST']}/{$agordoj['pado al la chefa dosierujo de paturage']}/{$agordoj['pado al la dosierdeponejo']}/" . $dosiero->leguKompletanNomon();
      }

      function leguURLonAlPatraPagho($mesagho='') {
         if($mesagho == '')
            $vosto='';
         else
            $vosto="&amp;mesagho=$mesagho";

         if($this->_paghTipo == 'foliumilo' ||
            $this->_paghTipo == 'vidajho' ||
            $_COOKIE['artiklo'] == 'NENIO')
            return 'index.php?' . $_COOKIE['foliumilo'] . $vosto;
         else
            return 'vidigu.php?' . $_COOKIE['artiklo'] . $vosto;
      }

      function leguURLonPorForigiArtiklon($artiklo) {
         return $this->leguURLonAlPatraPagho() . "&amp;forigu=" . $artiklo->leguIdentigilon();
      }

      function leguURLonPorKreiArtiklon($tipo) {
         return $this->leguURLonAlPatraPagho() . "&amp;kreu=$tipo";
      }

      function leguURLonPorRedaktiArtiklon($artiklo) {
         return $this->leguURLonAlPatraPagho() . "&amp;redaktu=" . $artiklo->leguIdentigilon();
      }

      function leguURLonPorAgo($ago) {
         return "index.php?ago=$ago&amp;" . $_COOKIE['foliumilo'];
      }

      function leguURLonAlKreaVidajho($tipo) {
         return "redaktu.php?kreu=$tipo";
      }

      function leguURLonAlRedaktaVidajho($artiklo) {
         return "redaktu.php?artiklo=" . $artiklo->leguIdentigilon();
      }

      function leguURLonAlArtiklaVidajho($artiklo) {
         return "vidigu.php?artiklo=" . $artiklo->leguIdentigilon();
      }

      function leguURLonAlFoliumaVidajho($etikedoj='') {
         if($etikedoj == '')
            return "index.php";
         else
            return "index.php?etikedoj=$etikedoj";
      }

      function leguURLonAlLumbildaVidajho($artiklo) {
         return "lumbildo.php?artiklo=" . $artiklo->leguIdentigilon();
      }

      function leguURLonAlChiTiuPagho() {
         $urlAlPagho = 'http';
         if ($_SERVER["HTTPS"] == "on")
            $urlAlPagho .= "s";
         $urlAlPagho .= "://";
         if ($_SERVER["SERVER_PORT"] != "80")
            $urlAlPagho .= $_SERVER["SERVER_NAME"].":".$_SERVER["SERVER_PORT"].urlencode($_SERVER["REQUEST_URI"]);
         else
            $urlAlPagho .= $_SERVER["SERVER_NAME"].urlencode($_SERVER["REQUEST_URI"]);
         return $urlAlPagho;
      }

      function leguEnsalutReghimon() {
         return $this->_ensaluto;
      }

      function chuGasto() {
         return $this->_ensaluto == 'gasto';
      }

      function chuUzanto() {
         return $this->_ensaluto == 'uzanto';
      }

      function chuAdministristo() {
         return $this->_ensaluto == 'administristo';
      }

      function chuAgoEstasPermesita($ago) {
         switch($ago) {
            case 'redaktu':
            case 'kreu':
            case 'forigu':
               return $this->_ensaluto == 'administristo';

            default:
               return true;
         }
      }

      function leguTradukon($cheno) {
         global $tradukoj, $aldonajTradukoj;
         if(array_key_exists($cheno, $aldonajTradukoj))
            return $aldonajTradukoj[$cheno];
         else if(array_key_exists($cheno, $tradukoj))
            return $tradukoj[$cheno];
         else
            return $cheno;
      }
   }
?>
