<?php
/* Ĉi tiu dosiero estas parto de Pâturage
 * 
 * Copyright (C) 2007 - Guillaume Savaton <llumeao@gmail.com>
 * 
 * Pâturage  estas libera programo;  vi  povas  ĝin  pludistribui  kaj/aŭ
 * modifi je la  kondiĉoj de la GNUa Ĝenerala Publika Permesilo, eldonita
 * de «Free Software Foundation», laŭ la versio 2 de tiu Permesilo aŭ, se
 * vi preferas, ajna posta versio.
 * 
 * Ni distribuas  ĉi tiun  programon esperante  ke ĝi estos  utila, tamen
 * SEN IA AJN GARANTIO,  i.a. sen la implica garantio pri SURMERKATIGEBLO
 * aŭ  TAŬGECO POR IU KONKRETA CELO. Pliajn  detalojn  vidu  en  la  GNUa
 * Ĝenerala Publika Permesilo.
 * 
 * Ekzemplero  de  la  GNUa  Ĝenerala Publika    Permesilo   devas   esti
 * liverita al vi kun ĉi tiu programo; ricevis, turnu vin al
 * 
 * Free Software Foundation
 * 51 Franklin Street, Fifth Floor
 * Boston, MA 02110-1301, USA
 * ------------------------------------------------------------------- */
?>
<?php
   require_once('klasoj/dosiera-vidajho.php');

   class PGLumbildaVidajho extends PGDosieraVidajho {

      function PGLumbildaVidajho($artiklo) {
         $this->PGDosieraVidajho($artiklo);
      }

      /**
       * @name Atingiloj
       */

      //@{

      /**
       * Liveru la URL-on al la miniaturo vidigebla en albumaj vidaĵoj
       *
       * Se la dosiero estas bildo, tiu funkcio liveros la URL-on de la
       * miniatura bildo vidigebla en la albumoj.
       *
       * @return La URL-on de la miniaturo por la dosiero
       */
      function leguURLonAlMiniaturo() {
         return "bildoj/min_" . $this->_artiklo->leguKompletanNomon();
      }

      //@}

      function vidigu() {
         global $kunteksto;
         include($kunteksto->leguDosierIndikonAlShablono('lumbildo'));
      }

      /**
       * @name Albuma interfaco
       *
       * Tiuj funkcioj estas vokeblaj de la albuma vidaĵo, kie la dosiero estos videbla.
       */

      //@{

      /**
       * Vidigu la dosieron, kiel miniaturo en albumo
       *
       * Tiu funkcio uzas la ŝablonan dosieron "miniaturo.php".
       */
      function vidiguMiniaturon() {
         global $kunteksto;
         include($kunteksto->leguDosierIndikonAlShablono('miniaturo'));
      }

      /**
       * Vidigu la kadron, kie lumbildo estos vidigata
       *
       * Tiu funkcio vidigas kadron, kie la lumbildo de la dosiero estos videbla.
       */
      function vidiguLumbildanKontenilon() {
         global $kunteksto;
         PGAranghisto::malfermuKadron('pg-lumbildo', 'pg-lumbildo', $kunteksto->leguURLonAlLumbildaVidajho($this->_artiklo));
         PGAranghisto::fermuKadron();
      }

      //@}

      /**
       * @name Ŝablona interfaco
       *
       * Tiuj funkcioj estas vokeblaj de la ŝablona dosiero "miniaturo.php".
       */

      //@{

      /**
       * Vidigu la miniaturan bildon de la dosiero
       *
       * Se la dosiero estas bildo, tiu funkcio vidigos la konforman miniaturon.
       * Alie, la piktogramo, kiu reprezentas la tipon de la dosiero, estos vidigata.
       *
       * Tiu funkcio estas vokebla el la ŝablona dosiero "miniaturo.php".
       */
      function vidiguMiniaturBildon() {
         if($this->_artiklo->leguDosierTipon() == 'bildo')
            $url = $this->leguURLonAlMiniaturo();
         else
            $url = $this->leguDosierIndikonAlPiktogramo();

         PGAranghisto::vidiguBildon(
               $url,
               'miniaturo',
               'pg-miniaturo-neselektita'
            );
      }

      //@}
   }
?>
