<?php
/* Ĉi tiu dosiero estas parto de Pâturage
 * 
 * Copyright (C) 2007 - Guillaume Savaton <llumeao@gmail.com>
 * 
 * Pâturage  estas libera programo;  vi  povas  ĝin  pludistribui  kaj/aŭ
 * modifi je la  kondiĉoj de la GNUa Ĝenerala Publika Permesilo, eldonita
 * de «Free Software Foundation», laŭ la versio 2 de tiu Permesilo aŭ, se
 * vi preferas, ajna posta versio.
 * 
 * Ni distribuas  ĉi tiun  programon esperante  ke ĝi estos  utila, tamen
 * SEN IA AJN GARANTIO,  i.a. sen la implica garantio pri SURMERKATIGEBLO
 * aŭ  TAŬGECO POR IU KONKRETA CELO. Pliajn  detalojn  vidu  en  la  GNUa
 * Ĝenerala Publika Permesilo.
 * 
 * Ekzemplero  de  la  GNUa  Ĝenerala Publika    Permesilo   devas   esti
 * liverita al vi kun ĉi tiu programo; ricevis, turnu vin al
 * 
 * Free Software Foundation
 * 51 Franklin Street, Fifth Floor
 * Boston, MA 02110-1301, USA
 * ------------------------------------------------------------------- */
?>
<?php
   require_once('klasoj/kunteksto.php');
   require_once('klasoj/vidajho.php');
   require_once('klasoj/artiklo.php');
   require_once('klasoj/etikedo.php');
   require_once('klasoj/etikeda-vidajho.php');
   require_once('klasoj/foliumila-vidajho.php');

   class PGRedaktilaVidajho extends PGVidajho {

      function vidigu() {
         global $kunteksto;
         include($kunteksto->leguDosierIndikonAlShablono('redaktilo'));
      }

      function vidiguRedaktanFormularon() {
         global $kunteksto;
         $tipoDeArtiklo = $kunteksto->leguArgumentonPriKreendaTipoDeArtiklo();

         if($tipoDeArtiklo == 'NENIO') {
            $agCheno = 'Redaktu';

            // Legu informojn pri la redaktota artiklo
            $artiklo = $kunteksto->leguArgumentonPriArtiklo();

            $kampoPriDosierNomo = $kampoPriNomoDeKolekto = $kampoPriUrl = $artiklo->leguNomon();
            $kampoPriTitolo = $artiklo->leguTitolon();
            $kampoPriPriskribo = $artiklo->leguPriskribon();
            $kampoPriRango = $artiklo->leguRangon();
            $kampoPriChuAlbumo = $artiklo->chuAlbumo();
            $kampoPriChuPrivata = $artiklo->chuPrivata();

            // Legu informojn pri la kolektoj, kiuj inkluzivas la artiklon
            $kolektoj = $artiklo->leguKolektojn();
            $kampoPriKolektoj = array();
            foreach($kolektoj as $c)
               $kampoPriKolektoj[] = $c->leguIdentigilon();

            // Legu informojn pri la etikedoj de la artiklo
            $etikedoj = $artiklo->leguEtikedojn();
            $kampoPriEtikedoj = '';
            foreach($etikedoj as $t) {
               if($kampoPriEtikedoj != '')
                  $kampoPriEtikedoj .= ', ';
               $kampoPriEtikedoj .= $t->leguNomon();
            }

            $tipoDeArtiklo = $artiklo->leguTiponKielCheno();
            $agUrl = $kunteksto->leguURLonPorRedaktiArtiklon($artiklo);

            $krei = false;
         }
         else {
            $agCheno = 'Kreu';

            $kampoPriDosierNomo = '';
            $kampoPriNomoDeKolekto = $kunteksto->leguTradukon('Tajpu la nomon de la kolekto');
            $kampoPriUrl = $kunteksto->leguTradukon('Tajpu la URLon de la legosigno');
            $kampoPriTitolo = $kunteksto->leguTradukon('Tajpu la titolon de tiu artiklo');
            $kampoPriPriskribo = $kunteksto->leguTradukon('Tajpu la priskribon de tiu artiklo');
            $kampoPriRango = 0;
            $kampoPriChuAlbumo = false;
            $kampoPriChuPrivata = false;
            $kampoPriKolektoj = array();
            $kampoPriEtikedoj = '';

            $agUrl = $kunteksto->leguURLonPorKreiArtiklon($tipoDeArtiklo);

            $krei = true;
         }

         PGAranghisto::vidiguTitolon(3, $kunteksto->leguTradukon("$agCheno {$tipoDeArtiklo}n"));

         PGAranghisto::malfermuFormularon('redaktilo', 'multipart/form-data', $agUrl, 'post');

         // Kampo pri la nomo aŭ URL de la artiklo
         switch($tipoDeArtiklo) {
            case 'dosiero':
               if($krei)
                  PGAranghisto::vidiguEnigilon($kunteksto->leguTradukon('Nomo de la dosiero:'), 'file', 'alshutilo', '');
               else {
                  PGAranghisto::vidiguEnigilon($kunteksto->leguTradukon('Nomo de la dosiero:'), 'text', 'nomo', $kampoPriDosierNomo);
                  PGAranghisto::vidiguEnigilon($kunteksto->leguTradukon('Alŝutu novan version:'), 'file', 'alshutilo', $kampoPriDosierNomo);
               }
               break;

            case 'legosigno':
               PGAranghisto::vidiguEnigilon($kunteksto->leguTradukon('URL de la legosigno:'), 'text', 'nomo', $kampoPriUrl);
               break;

            case 'kolekto':
               PGAranghisto::vidiguEnigilon($kunteksto->leguTradukon('Nomo de la kolekto:'), 'text', 'nomo', $kampoPriNomoDeKolekto);
               break;

            case 'albumo':
               PGAranghisto::vidiguEnigilon($kunteksto->leguTradukon('Nomo de la albumo:'), 'text', 'nomo', $kampoPriNomoDeKolekto);
               break;
         }

         // Kampoj pri la titolo kaj priskribo de la artiklo
         PGAranghisto::vidiguEnigilon($kunteksto->leguTradukon('Titolo:'), 'text', 'titolo',  $kampoPriTitolo);
         PGAranghisto::vidiguEnigilon($kunteksto->leguTradukon('Priskribo:'), 'textarea', 'priskribo', $kampoPriPriskribo);

         // Selektilo de rango
         PGAranghisto::malfermuRadiobutonanListon($kunteksto->leguTradukon('Rango:'), 'rango');
         for($i=0; $i<=$kunteksto->leguAgordonPriNombroDaRangoj(); $i++)
            PGAranghisto::vidiguOpcion($i, $i, $i==$kampoPriRango);
         PGAranghisto::fermuRadiobutonanListon();

         // Selektilo de privata stato
         PGAranghisto::vidiguEnigilon($kunteksto->leguTradukon('Ĉu privata?'), 'checkbox', 'chuPrivata', $kampoPriChuPrivata);

         // Informoj pri kolektoj
         switch($tipoDeArtiklo) {
            case 'dosiero':
            case 'legosigno':
               PGAranghisto::malfermuSekcionKunIdentigilo('pg-redaktilo-kolektoj');
               $kolektoj = PGArtiklo::leguChiujnKolektojn();
               foreach($kolektoj as $c) {
                  $teksto = $c->leguTitolon() . ' (' . $c->leguNomon() . ')';
                  PGAranghisto::vidiguEnigilon($teksto, 'checkbox', 'kolektoj[' . $c->leguIdentigilon() . ']', in_array($c->leguIdentigilon(), $kampoPriKolektoj));
               }
               PGAranghisto::fermuSekcion();
               break;

            case 'kolekto':
            case 'albumo':
               PGAranghisto::vidiguEnigilon($kunteksto->leguTradukon('Ĉu vidigota kiel albumo?'), 'checkbox', 'chuAlbumo', $kampoPriChuAlbumo);
               if(!$krei) {
                  PGAranghisto::malfermuSekcionKunIdentigilo('pg-redaktilo-kolektoj');
                  $enhavo = $artiklo->kielKolektoLeguArtiklojn();
                  foreach($enhavo as $i => $e) {
                     $teksto = $e->leguTitolon() . ' (' . $e->leguNomon() . ')';
                     PGAranghisto::vidiguEnigilon($teksto, 'radio', 'artikloj', $i == 0);
                     PGAranghisto::vidiguKashitanEnigilon("ordo[$i]", $i);
                  }
                  PGAranghisto::vidiguTekstanLigilon(
                        $kunteksto->leguTradukon('Supren'),
                        'javascript:movuSupren()',
                        $kunteksto->leguTradukon('Movu la selektitan artiklon al la supra pozicio')
                     );
                  PGAranghisto::vidiguTekstanLigilon(
                        $kunteksto->leguTradukon('Malsupren'),
                        'javascript:movuMalsupren()',
                        $kunteksto->leguTradukon('Movu la selektitan artiklon al la malsupra pozicio')
                     );
                  PGAranghisto::inkluzivuSkripton('skriptoj/kolekto.js');
                  PGAranghisto::fermuSekcion();
               }
         }

         // Kampo pri la etikedoj de tiu artiklo
         PGAranghisto::vidiguEnigilon($kunteksto->leguTradukon('Etikedoj:'), 'textarea', 'etikedoj', $kampoPriEtikedoj);

         // Butonoj por konservi/rezigni la ŝanĝojn
         PGAranghisto::malfermuSekcionKunIdentigilo('butonoj');
         PGAranghisto::vidiguEnigilon('', 'submit', 'konservu', $kunteksto->leguTradukon($agCheno));
         PGAranghisto::vidiguEnigilon('', 'button', 'rezignu', $kunteksto->leguTradukon('Rezignu'), $kunteksto->leguURLonAlPatraPagho());
         PGAranghisto::fermuSekcion();
         PGAranghisto::fermuFormularon();
      }

      function vidiguEtikedaron() {
         PGEtikedaVidajho::vidiguEtikedaron(true);
      }
   }
?>
