<?php
/* Ĉi tiu dosiero estas parto de Pâturage
 * 
 * Copyright (C) 2007 - Guillaume Savaton <llumeao@gmail.com>
 * 
 * Pâturage  estas libera programo;  vi  povas  ĝin  pludistribui  kaj/aŭ
 * modifi je la  kondiĉoj de la GNUa Ĝenerala Publika Permesilo, eldonita
 * de «Free Software Foundation», laŭ la versio 2 de tiu Permesilo aŭ, se
 * vi preferas, ajna posta versio.
 * 
 * Ni distribuas  ĉi tiun  programon esperante  ke ĝi estos  utila, tamen
 * SEN IA AJN GARANTIO,  i.a. sen la implica garantio pri SURMERKATIGEBLO
 * aŭ  TAŬGECO POR IU KONKRETA CELO. Pliajn  detalojn  vidu  en  la  GNUa
 * Ĝenerala Publika Permesilo.
 * 
 * Ekzemplero  de  la  GNUa  Ĝenerala Publika    Permesilo   devas   esti
 * liverita al vi kun ĉi tiu programo; ricevis, turnu vin al
 * 
 * Free Software Foundation
 * 51 Franklin Street, Fifth Floor
 * Boston, MA 02110-1301, USA
 * ------------------------------------------------------------------- */
?>
<?php
   require_once('klasoj/fabriko.php');
   require_once('klasoj/kunteksto.php');
   require_once('klasoj/artiklo.php');
   require_once('klasoj/dosiero.php');
   require_once('klasoj/etikedo.php');

   function kreuRegrandigitanBildon($dosierNomo, $prefikso, $maksLargho, $maksAlto, $perforte=0) {
      global $kunteksto;
      $finajho = PGDosiero::leguFinajhonEnNomo($dosierNomo);
      switch(strtolower($finajho)) {
         case 'jpg':
         case 'jpeg':
            $fontaBildo = imageCreateFromJPEG($kunteksto->leguDosierIndikonAlDosierDeponejo() . "/$dosierNomo");
            break;
         case 'png':
            $fontaBildo = imageCreateFromPNG($kunteksto->leguDosierIndikonAlDosierDeponejo() . "/$dosierNomo");
            break;
         case 'gif':
            $fontaBildo = imageCreateFromGIF($kunteksto->leguDosierIndikonAlDosierDeponejo() . "/$dosierNomo");
            break;
         default:
            return;
      }

      $largho = imageSX($fontaBildo);
      $alto = imageSY($fontaBildo);
      if($largho/$maksLargho > $alto/$maksAlto) {
         if($largho > $maksLargho || $perforte)
            $novaLargho = $maksLargho;
         else
            $novaLargho = $largho;
         $novaAlto = $alto * $novaLargho / $largho;
      }
      else {
         if($alto > $maksAlto || $perforte)
            $novaAlto = $maksAlto;
         else
            $novaAlto = $alto;
         $novaLargho = $largho * $novaAlto / $alto;
      }

      $novaBildo = imageCreateTrueColor($novaLargho, $novaAlto);
      imageCopyResampled($novaBildo, $fontaBildo, 0, 0, 0, 0, $novaLargho, $novaAlto, $largho, $alto);

      switch(strtolower($finajho)) {
         case 'jpg':
         case 'jpeg':
            imageJPEG($novaBildo, $kunteksto->leguDosierIndikonAlLaboraDosierujo() . "/$prefikso$dosierNomo");
            break;
         case 'png':
            imagePNG($novaBildo, $kunteksto->leguDosierIndikonAlLaboraDosierujo() . "/$prefikso$dosierNomo");
            break;
         case 'gif':
            imageGIF($novaBildo, $kunteksto->leguDosierIndikonAlLaboraDosierujo() . "/$prefikso$dosierNomo");
            break;
         default:
            return;
      }

      imageDestroy($fontaBildo);
      imageDestroy($novaBildo);
   }

   function ghisdatiguArtiklon() {
      global $kunteksto;

      switch($kunteksto->leguArgumentonPriKreendaTipoDeArtiklo()) {
         /*
          * Kreu novan dosieron
          */
         case 'dosiero':
            // Se neniu dosiero estas alŝutita, vidigu avertmesaĝon kaj finu
            if($kunteksto->leguKamponPriNomoDeAlshutitaDosiero() == '') {
               $kunteksto->skribuMesaghon('averto', $kunteksto->leguTradukon('Neniu dosiero estas alŝutita'));
               return;
            }

            // Kreu novan dosier-objekton kun la nomo de la alŝutita dosiero.
            // Kompleta nomo estas aŭtomate difinita por tiu dosiero.
            $dosiero = new PGDosiero($kunteksto->leguKamponPriNomoDeAlshutitaDosiero());

            // Movu la alŝutitan dosieron el la portempa dosierujo al la deponejo
            $rezulto = move_uploaded_file(
                  $kunteksto->leguKamponPriNomoDePortempaDosiero(),
                  $kunteksto->leguDosierIndikonAlDosierDeponejo() . '/' . $dosiero->leguKompletanNomon()
               );

            // Se la movo malsukcesis, vidigu avertmesaĝon kaj finu
            if(!$rezulto) {
               $kunteksto->skribuMesaghon(
                     'averto', $kunteksto->leguTradukon('Alŝuto malsukcesis por dosiero: ') .
                     $kunteksto->leguKamponPriNomo() .
                     ' [' . $kunteksto->leguKamponPriNomoDePortempaDosiero() .
                     '->' . $kunteksto->leguDosierIndikonAlDosierDeponejo() . '/' . $dosiero->leguKompletanNomon() . ']'
                  );
               return;
            }

            chmod($kunteksto->leguDosierIndikonAlDosierDeponejo() . '/' . $dosiero->leguKompletanNomon(), 0644);

            // Kreu novan dosier-artiklon kun la atributoj akiritaj el la formularo
            $artiklo = new PGDosieroNova(
                  $dosiero,
                  $kunteksto->leguKamponPriTitolo(),
                  $kunteksto->leguKamponPriPriskribo(),
                  $kunteksto->leguKamponPriRango(),
                  $kunteksto->leguKamponPriChuPrivata()
               );

            // Se temas pri bilda dosiero, kreu lumbildon kaj miniaturon
            if($dosiero->leguTipon() == 'bildo') {
               kreuRegrandigitanBildon(
                     $dosiero->leguKompletanNomon(),
                     'lum_',
                     $kunteksto->leguAgordonPriLarghoDeBildoj(),
                     $kunteksto->leguAgordonPriAltoDeBildoj()
                  );
               kreuRegrandigitanBildon(
                     $dosiero->leguKompletanNomon(),
                     'min_',
                     $kunteksto->leguAgordonPriLarghoDeMiniaturoj(),
                     $kunteksto->leguAgordonPriAltoDeMiniaturoj(),
                     1
                  );
            }
            break;

         /*
          * Kreu novan kolekton
          */
         case 'kolekto':
            $artiklo = new PGArtikloNova(
                  $kunteksto->leguKamponPriNomo(),
                  $kunteksto->leguKamponPriTitolo(),
                  $kunteksto->leguKamponPriPriskribo(),
                  $kunteksto->leguKamponPriRango(),
                  true,
                  false,
                  $kunteksto->leguKamponPriChuAlbumo(),
                  $kunteksto->leguKamponPriChuPrivata()
               );
            break;

         /*
          * Kreu novan legosignon
          */
         case 'legosigno':
            $artiklo = new PGArtikloNova(
                  $kunteksto->leguKamponPriNomo(),
                  $kunteksto->leguKamponPriTitolo(),
                  $kunteksto->leguKamponPriPriskribo(),
                  $kunteksto->leguKamponPriRango(),
                  false,
                  true,
                  false,
                  $kunteksto->leguKamponPriChuPrivata()
               );
            break;

         /*
          * Ĝisdatigu artiklon
          */
         case 'NENIO':
         default:
            // Legu la ĝisdatigotan artiklon
            $artiklo = $kunteksto->leguArgumentonPriRedaktendaArtiklo();

            // Por ĉiuj artikloj, ĝisdatigu la atributoj uzante la enhavon de la formularaj kampoj
            // Nur la nomo ne estas ĝisdatigota nun
            $artiklo->skribuTitolon($kunteksto->leguKamponPriTitolo());
            $artiklo->skribuPriskribon($kunteksto->leguKamponPriPriskribo());
            $artiklo->skribuRangon($kunteksto->leguKamponPriRango());
            $artiklo->ighuAlbumo($kunteksto->leguKamponPriChuAlbumo());
            $artiklo->ighuPrivata($kunteksto->leguKamponPriChuPrivata());

            // Se la artiklo estas dosiero, eble la uzanto renomis ĝin aŭ alŝutis novan version
            if($artiklo->chuDosiero()) {
               // Se ekzistas portempa dosiero, nova versio estas alŝutita
               if($kunteksto->leguKamponPriNomoDePortempaDosiero() != '') {
                  // Kreu novan dosier-objekton kun la nomo de la alŝutita dosiero.
                  // Kompleta nomo estas aŭtomate difinita por tiu dosiero.
                  $dosiero = new PGDosiero($kunteksto->leguKamponPriNomoDeAlshutitaDosiero());

                  // Movu la novan dosieron el la portempa dosierujo al la deponejo.
                  // La kompleta nomo de la dosiero en Pâturage ankoraŭ ne estas ŝanĝata
                  $rezulto = move_uploaded_file(
                        $kunteksto->leguKamponPriNomoDePortempaDosiero(),
                        $kunteksto->leguDosierIndikonAlDosierDeponejo() . '/' . $dosiero->leguKompletanNomon()
                     );
                  if(!$rezulto) {
                     $kunteksto->skribuMesaghon(
                           'averto', $kunteksto->leguTradukon('Alŝuto malsukcesis por dosiero: ') .
                           $kunteksto->leguKamponPriNomo()
                        );
                  }

                  // La nova dosiero devas esti legebla
                  chmod($kunteksto->leguDosierIndikonAlDosierDeponejo() . '/' . $dosiero->leguKompletanNomon(), 0644);

                  // Forviŝu la antaŭan dosieron
                  unlink($kunteksto->leguDosierIndikonAlDosierDeponejo() . '/' . $artiklo->leguKompletanNomon());

                  // Se temas pri bilda dosiero, kreu lumbildon kaj miniaturon
                  if($dosiero->leguTipon() == 'bildo') {
                     kreuRegrandigitanBildon(
                           $dosiero->leguKompletanNomon(),
                           'lum_',
                           $kunteksto->leguAgordonPriLarghoDeBildoj(),
                           $kunteksto->leguAgordonPriAltoDeBildoj()
                        );
                     kreuRegrandigitanBildon(
                           $dosiero->leguKompletanNomon(),
                           'min_',
                           $kunteksto->leguAgordonPriLarghoDeMiniaturoj(),
                           $kunteksto->leguAgordonPriAltoDeMiniaturoj(),
                           1
                        );
                  }

                  // Ĝisdatigu la nomon de la artiklo, uzante la nomon de la alŝutita dosiero
                  $artiklo->skribuNomon($kunteksto->leguKamponPriNomoDeAlshutitaDosiero());
                  $artiklo->skribuPrefikson($dosiero->leguPrefikson());
                  $artiklo->skribuSufikson($dosiero->leguSufikson());
               }

               // Se nova nomo estas tajpita, dosiero estas renomota
               else if($kunteksto->leguKamponPriNomo() != $artiklo->leguNomon()) {
                  // Kreu novan dosier-objekton kun la nomo tajpita en la formulara kampo
                  // Kompleta nomo estas aŭtomate difinita por tiu dosiero.
                  $dosiero = new PGDosiero($kunteksto->leguKamponPriNomo());

                  // Renomu la dosieron en la deponejo
                  rename(
                        $kunteksto->leguDosierIndikonAlDosierDeponejo() . '/' . $artiklo->leguKompletanNomon(),
                        $kunteksto->leguDosierIndikonAlDosierDeponejo() . '/' . $dosiero->leguKompletanNomon()
                     );

                  // Se temas pri bilda dosiero, ankaŭ renomu la lumbildon kaj la miniaturon
                  if($dosiero->leguTipon() == 'bildo') {
                     rename(
                           $kunteksto->leguDosierIndikonAlLaboraDosierujo() . '/lum_' . $artiklo->leguKompletanNomon(),
                           $kunteksto->leguDosierIndikonAlLaboraDosierujo() . '/lum_' . $dosiero->leguKompletanNomon()
                        );
                     rename(
                           $kunteksto->leguDosierIndikonAlLaboraDosierujo() . '/min_' . $artiklo->leguKompletanNomon(),
                           $kunteksto->leguDosierIndikonAlLaboraDosierujo() . '/min_' . $dosiero->leguKompletanNomon() 
                        );
                  }

                  // Anstataŭigu la nomon de la artiklo per la nova nomo
                  $artiklo->skribuNomon($kunteksto->leguKamponPriNomo());
                  $artiklo->skribuPrefikson($dosiero->leguPrefikson());
                  $artiklo->skribuSufikson($dosiero->leguSufikson());
               }
            }
            else
               // Ne-dosieraj artikloj estas rekte renomeblaj
               $artiklo->skribuNomon($kunteksto->leguKamponPriNomo());

            // Ĝisdatigu la datumbazon
            $artiklo->ghisdatigu();
      }

      $krei = $kunteksto->leguArgumentonPriKreendaTipoDeArtiklo() != 'NENIO';

      /*
       * Mastrumu kolektojn
       */
      if(!$artiklo->chuKolekto()) {
         // Se la artiklo jam ekzistis kaj ne estas kolekto, legu ĝiajn kolektojn
         if(!$krei)
            $foriguElKolektoj = $artiklo->leguKolektojn();

         // Laŭnecese, aldonu la artiklon al la kolektoj specifitaj en la formularo
         // aŭ forigu la artiklon el la kolektoj nespecifitaj en la formularo
         $kolektoj = $kunteksto->leguKamponPriKolektoj();
         foreach($kolektoj as $c) {
            if($krei)
               // Nova artiklo estas rekte aldonita al la kolekto
               $aldonuArtiklonAlKolekto = true;
            else {
               // Kontrolu ĉu la artiklo jam estas en la kolekto
               // Se jes, ne forigu la artiklon el la kolekto
               if($artiklo->chuEstasEnKolekto($c)) {
                  $aldonuArtiklonAlKolekto = false;
                  $foriguElKolektoj = $c->foriguElTabelo($foriguElKolektoj);
               }
               else
                  $aldonuArtiklonAlKolekto = true;
            }

            // Laŭnecese kreu ligon inter la artiklo kaj la kolekto
            if($aldonuArtiklonAlKolekto) {
               $c->kielKolektoAldonuArtiklon($artiklo);
            }
         }

         // Laŭnecese forigu la artiklon el kolektoj
         if(!$krei) {
            foreach($foriguElKolektoj as $c)
               $c->kielKolektoForiguArtiklon($artiklo);
         }
      }

      /*
       * Mastrumu etikedojn
       */

      // Se la artiklo jam ekzistas, preparu liston de ĝiaj etikedoj
      if(!$krei)
         $forigendajEtikedoj = $artiklo->leguEtikedojn();

      // Laŭnecese, aldonu al la artiklo la etikedojn specifitajn en la formularo
      // aŭ forigu el la artiklo la etikedojn nespecifitajn en la formularo.
      // Alvoki leguKamponPriEtikedoj aŭtomate kreas neekzistintajn etikedojn.
      $etikedoj = $kunteksto->leguKamponPriEtikedoj();
      foreach($etikedoj as $t) {
         if($t->chuNova())
            // Se la etikedo ĵus estas kreita, aldonu ĝin al la artiklo
            $aldonuEtikedonAlArtiklo = true;
         else {
            if($krei)
               // Se la artiklo ĵus estas kreita, aldonu la etikedon al ĝi
               $aldonuEtikedonAlArtiklo = true;
            else {
               // Alie, kontrolu ĉu la artiklo jam havas la etikedon
               // Se jes, ne forigu la etikedon el la artiklo
               if($artiklo->chuHavasEtikedon($t)) {
                  $aldonuEtikedonAlArtiklo = false;
                  $forigendajEtikedoj = $t->foriguElTabelo($forigendajEtikedoj);
               }
               else 
                  $aldonuEtikedonAlArtiklo = true;
            }
         }
         
         // Laŭnecese kreu ligon inter la artiklo kaj la etikedo
         if($aldonuEtikedonAlArtiklo)
            $artiklo->aldonuEtikedon($t);
      }

      // Laŭnecese forigu etikedojn el la artiklo
      // Etikedoj sen artiklo estas detruita
      if(!$krei) {
         foreach($forigendajEtikedoj as $t) {
            $artiklo->foriguEtikedon($t);
            if($t->leguNombronDaArtikloj() == 0)
               $t->forigu();
         }
      }

      /*
       * Mastrumu ordon en kolektoj
       */

      // Se la artiklo estas jam-ekzistinta kolekto,
      // reordigu ĝian enhavon laŭ la formulara kampo pri ordo
      if(!$krei && $artiklo->chuKolekto()) {
         $enhavo = $artiklo->kielKolektoLeguArtiklojn();
         foreach($kunteksto->leguKamponPriOrdo() as $nova => $malnova) {
            if($nova != $malnova)
               $artiklo->kielKolektoSkribuIndiconDeArtiklo($enhavo[$malnova], $nova);
         }
      }

      // Preparu mesaĝon por indiki sukceson de la kreado/ĝistadigo
      if($krei)
         $kunteksto->skribuMesaghon('informo', $kunteksto->leguTradukon('Artiklo estas sukcese kreita'));
      else
         $kunteksto->skribuMesaghon('informo', $kunteksto->leguTradukon('Artiklo estas sukcese ĝisdatigita'));
   }
?>
